//--------------------------------------------------------
//  Zelda Classic
//  by Jeremy Craner, 1999-2000
//
//  subscr.cc
//
//  Subscreen code for zelda.cc
//
//--------------------------------------------------------

#include "precompiled.h" //always first

#include "subscr.h"
#include "zelda.h"
#include "tiles.h"
#include "zsys.h"
#include "guys.h"
#include "link.h"
#include "items.h"
#include <stdio.h>
#include <string.h>
#include "gc.h"

bool show_subscreen_dmap_dots=true;
bool show_subscreen_numbers=true;
bool show_subscreen_items=true;
bool show_subscreen_life=true;
bool new_sel=false;

extern sprite_list  guys, items, Ewpns, Lwpns, Sitems, chainlinks, decorations;
extern LinkClass   Link;

subscreen_group *current_subscreen_active;
subscreen_group *current_subscreen_passive;

subscreen_group custom_subscreen[MAXCUSTOMSUBSCREENS];

static const int notscrolling = sspUP | sspDOWN;
static const int pos = notscrolling | sspSCROLLING;

subscreen_object z3_active_a[80]=
{
    //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
    { ssoRECT,                             pos,                      0,           0,         256,          168,            ssctMISC,                  ssctSUBSCRBG,                      ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { sso2X2FRAME,                         pos,                      8,           0,          19,           12,            7,                         0,                                 0,                         0,                                 0,                         0,                             20040,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { sso2X2FRAME,                         pos,                      8,          96,          19,            9,            8,                         0,                                 0,                         0,                                 0,                         0,                             20040,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { sso2X2FRAME,                         pos,                    168,           0,          10,            6,            7,                         0,                                 0,                         0,                                 0,                         0,                             20040,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { sso2X2FRAME,                         pos,                    168,          48,          10,            7,            8,                         0,                                 0,                         0,                                 0,                         0,                             20040,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { sso2X2FRAME,                         pos,                    168,         104,          10,            8,            8,                         0,                                 0,                         0,                                 0,                         0,                             20040,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { sso2X2FRAME,                         pos,                      8,           0,          19,           12,            7,                         0,                                 0,                         0,                                 0,                         0,                             20040,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { sso2X2FRAME,                         pos,                      8,          96,          19,            9,            8,                         0,                                 0,                         0,                                 0,                         0,                             20040,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { sso2X2FRAME,                         pos,                    168,           0,          10,            6,            7,                         0,                                 0,                         0,                                 0,                         0,                             20040,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { sso2X2FRAME,                         pos,                    168,          48,          10,            7,            8,                         0,                                 0,                         0,                                 0,                         0,                             20040,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { sso2X2FRAME,                         pos,                    168,         104,          10,            8,            8,                         0,                                 0,                         0,                                 0,                         0,                             20040,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    176,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_sword,                  1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    200,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_shield,                 1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    224,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ring,                   1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    200,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_heartpiece,             1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     28,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_raft,                   1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     52,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_book,                   1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     76,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ladder,                 1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    100,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_magickey,               1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    124,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wallet,                 1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     28,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_boots,                  1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     52,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bracelet,               1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     76,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_flippers,               1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    100,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_amulet,                 1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    124,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_quiver,                 1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoSELECTOR2,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     32,          16,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bowandarrow,            1,                      0,                          10,                      5,                     14,                      1,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                     44,          26,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaCENTER,             sstsOUTLINEDPLUS,            2,                      '~',                    0,                      sscARROWS,              0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     56,          16,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_brang,                  1,                      1,                          11,                      6,                      0,                      2,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     80,          16,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_hookshot,               1,                      2,                          12,                      7,                      1,                      3,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    104,          16,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bomb,                   1,                      3,                          13,                      8,                      2,                      4,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                    116,          26,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaCENTER,             sstsOUTLINEDPLUS,            2,                      '~',                    0,                      sscBOMBS,               0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    128,          16,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_letterpotion,           1,                      4,                          14,                      9,                      3,                      5,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     32,          40,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wand,                   1,                      5,                           0,                     10,                      4,                      6,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     56,          40,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_sbomb,                  1,                      6,                           1,                     11,                      5,                      7,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                     68,          50,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaCENTER,             sstsOUTLINEDPLUS,            2,                      '~',                    0,                      sscSBOMBS,              0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     80,          40,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_dinsfire,               1,                      7,                           2,                     12,                      6,                      8,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    104,          40,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_nayruslove,             1,                      8,                           3,                     13,                      7,                      9,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    128,          40,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_faroreswind,            1,                      9,                           4,                     14,                      8,                     10,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     32,          64,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_candle,                 1,                     10,                           5,                      0,                      9,                     11,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     56,          64,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_hammer,                 1,                     11,                           6,                      1,                     10,                     12,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     80,          64,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_whistle,                1,                     12,                           7,                      2,                     11,                     13,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    104,          64,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_lens,                   1,                     13,                           8,                      3,                     12,                     14,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    128,          64,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bait,                   1,                     14,                           9,                      4,                     13,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    177,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    181,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    185,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    189,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    193,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    197,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    201,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    205,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    209,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    213,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    217,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    221,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    225,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    229,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    233,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    237,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoBUTTONITEM,                       pos,                    200,           8,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                    212,          18,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaCENTER,             sstsOUTLINEDPLUS,            2,                      '~',                    2,                      sscARROWS,              0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                    212,          18,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaCENTER,             sstsOUTLINEDPLUS,            2,                      '~',                    2,                      sscBOMBS,               0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                    212,          18,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaCENTER,             sstsOUTLINEDPLUS,            2,                      '~',                    2,                      sscSBOMBS,              0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoSELECTEDITEMNAME,                 pos,                    173,          24,          70,           16,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,               -1,                                 ssfPROP,                      sstaCENTER,             sstsSHADOWED,                1,                      4,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoRECT,                             pos,                     24,           1,          16,            6,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoTEXT,                             pos,                     24,           1,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaLEFT,               sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *)"ITEM" },
    { ssoTEXT,                             pos,                     17,         105,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaLEFT,               sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *)"INVENTORY" },
    { ssoTEXT,                             pos,                    177,          57,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaLEFT,               sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *)"TRIFORCE" },
    { ssoTEXT,                             pos,                    177,         113,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaLEFT,               sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *)"EQUIPMENT" },
    { ssoTRIFORCE,                         pos,                    192,          64,           1,            1,            ssctMISC,                  sscsTRIFORCECSET,                  0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoTRIFORCE,                         pos,                    208,          64,           1,            1,            ssctMISC,                  sscsTRIFORCECSET,                  0,                         0,                                 0,                         0,                                 0,                            1,                      1,                           0,                      2,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoTRIFORCE,                         pos,                    176,          80,           1,            1,            ssctMISC,                  sscsTRIFORCECSET,                  0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      3,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoTRIFORCE,                         pos,                    224,          80,           1,            1,            ssctMISC,                  sscsTRIFORCECSET,                  0,                         0,                                 0,                         0,                                 0,                            1,                      1,                           0,                      4,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoTRIFORCE,                         pos,                    192,          80,           1,            1,            ssctMISC,                  sscsTRIFORCECSET,                  0,                         0,                                 0,                         0,                                 0,                            2,                      1,                           0,                      5,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoTRIFORCE,                         pos,                    192,          80,           1,            1,            ssctMISC,                  sscsTRIFORCECSET,                  0,                         0,                                 0,                         0,                                 0,                            1,                      1,                           0,                      6,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoTRIFORCE,                         pos,                    208,          80,           1,            1,            ssctMISC,                  sscsTRIFORCECSET,                  0,                         0,                                 0,                         0,                                 0,                            3,                      1,                           0,                      7,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoTRIFORCE,                         pos,                    208,          80,           1,            1,            ssctMISC,                  sscsTRIFORCECSET,                  0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      8,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoTILEBLOCK,                        pos,                     16,           8,           1,            1,            1,                         0,                                 0,                         0,                                 0,                         0,                             28201,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
};
subscreen_object z3_active_ab[82]=
{
    //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
    { ssoRECT,                             pos,                      0,           0,         256,          168,            ssctMISC,                  ssctSUBSCRBG,                      ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { sso2X2FRAME,                         pos,                      8,           0,          19,           12,            7,                         0,                                 0,                         0,                                 0,                         0,                             20040,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { sso2X2FRAME,                         pos,                      8,          96,          19,            9,            8,                         0,                                 0,                         0,                                 0,                         0,                             20040,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { sso2X2FRAME,                         pos,                    168,           0,          10,            6,            7,                         0,                                 0,                         0,                                 0,                         0,                             20040,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { sso2X2FRAME,                         pos,                    168,          48,          10,            7,            8,                         0,                                 0,                         0,                                 0,                         0,                             20040,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { sso2X2FRAME,                         pos,                    168,         104,          10,            8,            8,                         0,                                 0,                         0,                                 0,                         0,                             20040,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { sso2X2FRAME,                         pos,                      8,           0,          19,           12,            7,                         0,                                 0,                         0,                                 0,                         0,                             20040,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { sso2X2FRAME,                         pos,                      8,          96,          19,            9,            8,                         0,                                 0,                         0,                                 0,                         0,                             20040,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { sso2X2FRAME,                         pos,                    168,           0,          10,            6,            7,                         0,                                 0,                         0,                                 0,                         0,                             20040,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { sso2X2FRAME,                         pos,                    168,          48,          10,            7,            8,                         0,                                 0,                         0,                                 0,                         0,                             20040,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { sso2X2FRAME,                         pos,                    168,         104,          10,            8,            8,                         0,                                 0,                         0,                                 0,                         0,                             20040,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    176,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_sword,                  1,                     15,                          14,                      0,                     14,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    200,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_shield,                 1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    224,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ring,                   1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    200,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_heartpiece,             1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     28,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_raft,                   1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     52,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_book,                   1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     76,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ladder,                 1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    100,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_magickey,               1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    124,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wallet,                 1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     28,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_boots,                  1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     52,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bracelet,               1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     76,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_flippers,               1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    100,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_amulet,                 1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    124,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_quiver,                 1,                     -1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoSELECTOR2,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     32,          16,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bowandarrow,            1,                      0,                          10,                      5,                     15,                      1,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                     44,          26,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaCENTER,             sstsOUTLINEDPLUS,            2,                      '~',                    0,                      sscARROWS,              0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     56,          16,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_brang,                  1,                      1,                          11,                      6,                      0,                      2,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     80,          16,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_hookshot,               1,                      2,                          12,                      7,                      1,                      3,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    104,          16,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bomb,                   1,                      3,                          13,                      8,                      2,                      4,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                    116,          26,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaCENTER,             sstsOUTLINEDPLUS,            2,                      '~',                    0,                      sscBOMBS,               0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    128,          16,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_letterpotion,           1,                      4,                          14,                      9,                      3,                      5,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     32,          40,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wand,                   1,                      5,                           0,                     10,                      4,                      6,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     56,          40,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_sbomb,                  1,                      6,                           1,                     11,                      5,                      7,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                     68,          50,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaCENTER,             sstsOUTLINEDPLUS,            2,                      '~',                    0,                      sscSBOMBS,              0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     80,          40,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_dinsfire,               1,                      7,                           2,                     12,                      6,                      8,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    104,          40,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_nayruslove,             1,                      8,                           3,                     13,                      7,                      9,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    128,          40,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_faroreswind,            1,                      9,                           4,                     14,                      8,                     10,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     32,          64,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_candle,                 1,                     10,                           5,                      0,                      9,                     11,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     56,          64,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_hammer,                 1,                     11,                           6,                      1,                     10,                     12,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                     80,          64,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_whistle,                1,                     12,                           7,                      2,                     11,                     13,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    104,          64,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_lens,                   1,                     13,                           8,                      3,                     12,                     14,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCURRENTITEM,                      pos,                    128,          64,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bait,                   1,                     14,                           9,                      4,                     13,                     15,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoSELECTOR1,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    177,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    181,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    185,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    189,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    193,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    197,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    201,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    205,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    209,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    213,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    217,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    221,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    225,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    229,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    233,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    237,         139,           2,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoBUTTONITEM,                       pos,                    200,           8,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                    212,          18,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaCENTER,             sstsOUTLINEDPLUS,            2,                      '~',                    2,                      sscARROWS,              0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                    212,          18,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaCENTER,             sstsOUTLINEDPLUS,            2,                      '~',                    2,                      sscBOMBS,               0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                    212,          18,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaCENTER,             sstsOUTLINEDPLUS,            2,                      '~',                    2,                      sscSBOMBS,              0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoSELECTEDITEMNAME,                 pos,                    173,          24,          70,           16,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,               -1,                                 ssfPROP,                      sstaCENTER,             sstsSHADOWED,                1,                      4,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoRECT,                             pos,                     24,           1,          16,            6,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoTEXT,                             pos,                     24,           1,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaLEFT,               sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *)"ITEM" },
    { ssoTILEBLOCK,                        pos,                     16,          73,           1,            1,            1,                         0,                                 0,                         0,                                 0,                         0,                             28201,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoTEXT,                             pos,                     17,         105,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaLEFT,               sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *)"INVENTORY" },
    { ssoTEXT,                             pos,                    177,          57,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaLEFT,               sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *)"TRIFORCE" },
    { ssoTEXT,                             pos,                    177,         113,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaLEFT,               sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *)"EQUIPMENT" },
    { ssoTRIFORCE,                         pos,                    192,          64,           1,            1,            ssctMISC,                  sscsTRIFORCECSET,                  0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoTRIFORCE,                         pos,                    208,          64,           1,            1,            ssctMISC,                  sscsTRIFORCECSET,                  0,                         0,                                 0,                         0,                                 0,                            1,                      1,                           0,                      2,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoTRIFORCE,                         pos,                    176,          80,           1,            1,            ssctMISC,                  sscsTRIFORCECSET,                  0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      3,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoTRIFORCE,                         pos,                    224,          80,           1,            1,            ssctMISC,                  sscsTRIFORCECSET,                  0,                         0,                                 0,                         0,                                 0,                            1,                      1,                           0,                      4,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoTRIFORCE,                         pos,                    192,          80,           1,            1,            ssctMISC,                  sscsTRIFORCECSET,                  0,                         0,                                 0,                         0,                                 0,                            2,                      1,                           0,                      5,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoTRIFORCE,                         pos,                    192,          80,           1,            1,            ssctMISC,                  sscsTRIFORCECSET,                  0,                         0,                                 0,                         0,                                 0,                            1,                      1,                           0,                      6,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoTRIFORCE,                         pos,                    208,          80,           1,            1,            ssctMISC,                  sscsTRIFORCECSET,                  0,                         0,                                 0,                         0,                                 0,                            3,                      1,                           0,                      7,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoTRIFORCE,                         pos,                    208,          80,           1,            1,            ssctMISC,                  sscsTRIFORCECSET,                  0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      8,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoTILEBLOCK,                        pos,                     16,           8,           1,            1,            1,                         0,                                 0,                         0,                                 0,                         0,                                 28200,                        0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
};
subscreen_object z3_passive_a[66]=
{
    //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
    { ssoCLEAR,                            pos,                      0,           0,           0,            0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoMINITILE,                         pos,                     74,           6,           0,            0,            5,                         0,                                 0,                         0,                                 0,                         0,                            101069,                            0,                      0,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoMINITILE,                         pos,                    101,           6,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                            101369,                            0,                      0,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoMINITILE,                         pos,                    126,           7,           0,            0,            1,                         0,                                 0,                         0,                                 0,                         0,                            101683,                            0,                      0,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoMINITILE,                         pos,                    144,           6,           0,            0,            1,                         0,                                 0,                         0,                                 0,                         0,                            101212,                            0,                      0,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     16,           8,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 9,                       100320,                 100640,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     16,          12,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 8,                       100320,                 100640,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     16,          16,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 7,                       100320,                 100640,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     16,          20,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 6,                       100320,                 100640,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     16,          24,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 5,                       100320,                 100640,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     16,          28,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 4,                       100320,                 100640,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     16,          32,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 3,                       100320,                 100640,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     16,          36,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 2,                       100320,                 100640,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     16,          40,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 1,                       100320,                 100640,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     16,          44,           8,            8,            5,                         5,                                 5,                         5,                                 0,                         0,                                 0,                       100322,                 100260,                      100322,                 100322,                      1,                      0,                      0,                      2,                      0,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     24,           8,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 9,                       100480,                 100720,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     24,          12,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 8,                       100480,                 100720,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     24,          16,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 7,                       100480,                 100720,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     24,          20,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 6,                       100480,                 100720,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     24,          24,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 5,                       100480,                 100720,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     24,          28,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 4,                       100480,                 100720,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     24,          32,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 3,                       100480,                 100720,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     24,          36,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 2,                       100480,                 100720,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     24,          40,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 1,                       100480,                 100720,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     24,          44,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 0,                       100323,                 100260,                      100262,                 100263,                      1,                      0,                      0,                      2,                      0,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     16,          44,           8,            8,            5,                         5,                                 5,                         5,                                 0,                         0,                                 0,                       100402,                 100260,                      100322,                 100322,                      1,                      0,                      0,                      1,                      0,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     24,          44,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 0,                       100403,                 100260,                      100262,                 100263,                      1,                      0,                      0,                      1,                      0,                      0,             0,            0,            0,             NULL },
    { sso2X2FRAME,                         pos,                     32,           4,           4,            4,            7,                         0,                                 0,                         0,                                 0,                         0,                             20040,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoBUTTONITEM,                       pos,                     40,          12,          16,           16,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                     52,          22,           9,            7,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaCENTER,             sstsOUTLINEDPLUS,            2,                      '~',                    2,                      sscARROWS,              0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                     52,          22,           9,            7,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaCENTER,             sstsOUTLINEDPLUS,            2,                      '~',                    2,                      sscBOMBS,               0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                     52,          22,           9,            7,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaCENTER,             sstsOUTLINEDPLUS,            2,                      '~',                    2,                      sscSBOMBS,              0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoTEXT,                             pos,                    200,           6,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfSS4,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *)"LIFE" },
    { ssoRECT,                             pos,                    178,           8,          12,            2,            0,                         15,                                0,                        15,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    179,           8,          10,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoRECT,                             pos,                    210,           8,          12,            2,            0,                         15,                                0,                        15,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    211,           8,          10,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    169,          15,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                 1,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    177,          15,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                 2,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    185,          15,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                 3,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    193,          15,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                 4,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    201,          15,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                 5,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    209,          15,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                 6,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    217,          15,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                 7,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    225,          15,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                 8,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    169,          23,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                 9,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    177,          23,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                10,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    185,          23,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                11,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    193,          23,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                12,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    201,          23,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                13,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    209,          23,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                14,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    217,          23,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                15,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    225,          23,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                16,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    169,          31,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                17,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    177,          31,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                18,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    185,          31,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                19,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    193,          31,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                20,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    201,          31,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                21,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    209,          31,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                22,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    217,          31,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                23,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    225,          31,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                24,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                     77,          15,          25,            9,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfSS4,                       sstaCENTER,             sstsSHADOWED,                3,                      '~',                    1,                      sscRUPEES,              0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                    105,          15,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfSS4,                       sstaCENTER,             sstsSHADOWED,                2,                      '~',                    1,                      sscBOMBS,               0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                    129,          15,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfSS4,                       sstaCENTER,             sstsSHADOWED,                2,                      '~',                    1,                      sscARROWS,              0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                    148,          15,           9,            9,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfSS4,                       sstaCENTER,             sstsSHADOWED,                1,                      '~',                    1,                      sscGENKEYMAGIC,         0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
};
subscreen_object z3_passive_ab[75]=
{
    //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
    { ssoCLEAR,                            pos,                      0,           0,           0,            0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoMINITILE,                         pos,                     80,           6,           0,            0,            5,                         0,                                 0,                         0,                                 0,                         0,                            101069,                            0,                      0,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoMINITILE,                         pos,                    107,           6,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                            101369,                            0,                      0,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoMINITILE,                         pos,                    132,           7,           0,            0,            1,                         0,                                 0,                         0,                                 0,                         0,                            101683,                            0,                      0,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoMINITILE,                         pos,                    150,           6,           0,            0,            1,                         0,                                 0,                         0,                                 0,                         0,                            101212,                            0,                      0,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     16,           8,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 9,                       100320,                 100640,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     16,          12,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 8,                       100320,                 100640,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     16,          16,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 7,                       100320,                 100640,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     16,          20,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 6,                       100320,                 100640,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     16,          24,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 5,                       100320,                 100640,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     16,          28,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 4,                       100320,                 100640,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     16,          32,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 3,                       100320,                 100640,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     16,          36,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 2,                       100320,                 100640,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     16,          40,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 1,                       100320,                 100640,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     16,          44,           8,            8,            5,                         5,                                 5,                         5,                                 0,                         0,                                 0,                       100322,                 100260,                      100322,                 100322,                      1,                      0,                      0,                      2,                      0,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     24,           8,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 9,                       100480,                 100720,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     24,          12,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 8,                       100480,                 100720,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     24,          16,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 7,                       100480,                 100720,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     24,          20,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 6,                       100480,                 100720,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     24,          24,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 5,                       100480,                 100720,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     24,          28,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 4,                       100480,                 100720,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     24,          32,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 3,                       100480,                 100720,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     24,          36,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 2,                       100480,                 100720,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     24,          40,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 1,                       100480,                 100720,                      100262,                 100263,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     24,          44,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 0,                       100323,                 100260,                      100262,                 100263,                      1,                      0,                      0,                      2,                      0,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     16,          44,           8,            8,            5,                         5,                                 5,                         5,                                 0,                         0,                                 0,                       100402,                 100260,                      100322,                 100322,                      1,                      0,                      0,                      1,                      0,                      0,             0,            0,            0,             NULL },
    { ssoMAGICGAUGE,                       pos,                     24,          44,           8,            8,            5,                         5,                                 5,                         0,                                 0,                         0,                                 0,                       100403,                 100260,                      100262,                 100263,                      1,                      0,                      0,                      1,                      0,                      0,             0,            0,            0,             NULL },
    { sso2X2FRAME,                         pos,                     32,          26,           4,            4,            8,                         0,                                 0,                         0,                                 0,                         0,                             20040,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { sso2X2FRAME,                         pos,                     32,           0,           4,            4,            7,                         0,                                 0,                         0,                                 0,                         0,                             20040,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoBUTTONITEM,                       pos,                     40,           8,          16,           16,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                     52,          18,           9,            7,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaCENTER,             sstsOUTLINEDPLUS,            2,                      '~',                    2,                      sscARROWS,              0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                     52,          18,           9,            7,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaCENTER,             sstsOUTLINEDPLUS,            2,                      '~',                    2,                      sscBOMBS,               0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                     52,          18,           9,            7,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaCENTER,             sstsOUTLINEDPLUS,            2,                      '~',                    2,                      sscSBOMBS,              0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoBUTTONITEM,                       pos,                     40,          34,          16,           16,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                     52,          44,           9,            7,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaCENTER,             sstsOUTLINEDPLUS,            2,                      '~',                    2,                      sscARROWS,              0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                     52,          44,           9,            7,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaCENTER,             sstsOUTLINEDPLUS,            2,                      '~',                    2,                      sscBOMBS,               0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                     52,          44,           9,            7,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfZ3SMALL,                   sstaCENTER,             sstsOUTLINEDPLUS,            2,                      '~',                    2,                      sscSBOMBS,              0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoTEXT,                             pos,                    200,           6,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfSS4,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *)"LIFE" },
    { ssoRECT,                             pos,                    178,           8,          12,            2,            0,                         15,                                0,                        15,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    179,           8,          10,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoRECT,                             pos,                    210,           8,          12,            2,            0,                         15,                                0,                        15,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLINE,                             pos,                    211,           8,          10,            1,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    169,          15,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                 1,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    177,          15,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                 2,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    185,          15,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                 3,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    193,          15,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                 4,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    201,          15,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                 5,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    209,          15,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                 6,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    217,          15,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                 7,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    225,          15,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                 8,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    169,          23,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                 9,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    177,          23,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                10,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    185,          23,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                11,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    193,          23,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                12,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    201,          23,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                13,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    209,          23,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                14,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    217,          23,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                15,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    225,          23,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                16,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    169,          31,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                17,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    177,          31,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                18,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    185,          31,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                19,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    193,          31,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                20,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    201,          31,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                21,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    209,          31,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                22,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    217,          31,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                23,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoLIFEGAUGE,                        pos,                    225,          31,           8,            8,            1,                         1,                                 1,                         1,                                 0,                         0,                                24,                       100240,                 100240,                      100261,                 100261,                      1,                      0,                      0,                      0,                      3,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                     83,          15,          25,            9,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfSS4,                       sstaCENTER,             sstsSHADOWED,                3,                      '~',                    1,                      sscRUPEES,              0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                    111,          15,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfSS4,                       sstaCENTER,             sstsSHADOWED,                2,                      '~',                    1,                      sscBOMBS,               0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                    135,          15,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfSS4,                       sstaCENTER,             sstsSHADOWED,                2,                      '~',                    1,                      sscARROWS,              0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoCOUNTER,                          pos,                    154,          15,           9,            9,            ssctMISC,                  ssctTEXT,                          0,                        15,                                 ssctSYSTEM,               -1,                                 ssfSS4,                       sstaCENTER,             sstsSHADOWED,                1,                      '~',                    1,                      sscGENKEYMAGIC,         0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoRECT,                             pos,                     59,          11,           4,           10,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoRECT,                             pos,                     59,          37,           4,           10,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
    { ssoTEXT,                             pos,                     61,          13,           8,            8,            0,                         1,                                 0,                         0,                                 0,                         0,                                 ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *)"A" },
    { ssoTEXT,                             pos,                     61,          38,           8,            8,            0,                         1,                                 0,                         0,                                 0,                         0,                                 ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *)"B" },
    { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
};

subscreen_object default_subscreen_active[ssdtMAX][2][66]=//[zinit.subscreen][dungeon]
{
    {
        //ssdtOLD
        {
            //ssdtOLD,      overworld
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoRECT,                             pos,                      0,           0,         256,          168,            ssctMISC,                  ssctSUBSCRBG,                      ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     68,          18,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "INVENTORY" },
            { sso2X2FRAME,                         pos,                     56,          34,           4,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     64,          66,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "USE B BUTTON" },
            { ssoTEXT,                             pos,                     64,          74,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "FOR THIS" },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    128,         154,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "TRIFORCE" },
            { ssoTRIFRAME,                         pos,                     80,          98,           0,            0,            ssctMISC,                  ssctTRIFRAMECOLOR,                 ssctMISC,                  ssctCAPTION,                       0,                         0,                                 0,                            0,                      0,                           0,                      1,                      1,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    120,          34,          13,            6,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       notscrolling,            64,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           128,          18,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_raft,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           148,          18,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_book,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           160,          18,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ring,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           176,          18,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ladder,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           192,          18,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_magickey,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           204,          18,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bracelet,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSELECTOR2,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           172,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           180,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bow,                    1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           128,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_brang,                  1,                      0,                           4,                      4,                      7,                      1,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           152,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bomb,                   1,                      1,                           5,                      5,                      0,                      2,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           176,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  0,                      2,                           6,                      6,                      1,                      3,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           200,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_candle,                 1,                      3,                           7,                      7,                      2,                      4,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           128,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_whistle,                1,                      4,                           0,                      0,                      3,                      5,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           152,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bait,                   1,                      5,                           1,                      1,                      4,                      6,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           176,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_letterpotion,           1,                      6,                           2,                      2,                      5,                      7,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           200,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wand,                   1,                      7,                           3,                      3,                      6,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSELECTOR1,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        },
        {
            //ssdtOLD,      dungeon
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoRECT,                             pos,                      0,           0,         256,          168,            ssctMISC,                  ssctSUBSCRBG,                      ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     68,          18,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "INVENTORY" },
            { sso2X2FRAME,                         pos,                     56,          34,           4,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     64,          66,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "USE B BUTTON" },
            { ssoTEXT,                             pos,                     64,          74,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "FOR THIS" },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLARGEMAP,                         pos,                     96,          82,           0,            0,            ssctMISC,                  ssctBMAPFG,                        ssctMISC,                  ssctLINKDOT,                       0,                         0,                                 1,                            1,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      1,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     52,          90,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "MAP" },
            { ssoTEXT,                             pos,                     52,         130,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "COMPASS" },
            { ssoCURRENTITEM,                      notscrolling,            44,         106,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_map,                    1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,            44,         146,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_compass,                1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    120,          34,          13,            6,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       notscrolling,            64,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           128,          18,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_raft,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           148,          18,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_book,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           160,          18,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ring,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           176,          18,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ladder,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           192,          18,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_magickey,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           204,          18,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bracelet,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSELECTOR2,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           172,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           180,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bow,                    1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           128,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_brang,                  1,                      0,                           4,                      4,                      7,                      1,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           152,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bomb,                   1,                      1,                           5,                      5,                      0,                      2,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           176,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  0,                      2,                           6,                      6,                      1,                      3,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           200,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_candle,                 1,                      3,                           7,                      7,                      2,                      4,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           128,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_whistle,                1,                      4,                           0,                      0,                      3,                      5,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           152,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bait,                   1,                      5,                           1,                      1,                      4,                      6,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           176,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_letterpotion,           1,                      6,                           2,                      2,                      5,                      7,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      notscrolling,           200,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wand,                   1,                      7,                           3,                      3,                      6,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSELECTOR1,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        }
    },
    {
        //ssdtNEWSUBSCR
        {
            //ssdtNEWSUBSCR,      overworld
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoRECT,                             pos,                      0,           0,         256,          168,            ssctMISC,                  ssctSUBSCRBG,                      ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     68,          18,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "INVENTORY" },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                     12,          34,          14,            6,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    128,         154,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "TRIFORCE" },
            { ssoTRIFRAME,                         pos,                     80,          98,           0,            0,            ssctMISC,                  ssctTRIFRAMECOLOR,                 ssctMISC,                  ssctCAPTION,                       0,                         0,                                 0,                            0,                      0,                           0,                      1,                      1,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    136,          18,          13,            8,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     20,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_raft,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     36,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_book,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     52,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ring,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     68,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ladder,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     84,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_magickey,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    100,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bracelet,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     20,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_shield,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     36,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wallet,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     52,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_amulet,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     68,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_flippers,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     84,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_boots,                  1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    100,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_heartpiece,             1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSELECTOR2,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    188,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    196,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bow,                    1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    144,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_brang,                  1,                      0,                           8,                      4,                     11,                      1,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    168,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bomb,                   1,                      1,                           9,                      5,                      0,                      2,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    192,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  0,                      2,                          10,                      6,                      1,                      3,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    216,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_candle,                 1,                      3,                          11,                      7,                      2,                      4,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    144,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_whistle,                1,                      4,                           0,                      8,                      3,                      5,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    168,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bait,                   1,                      5,                           1,                      9,                      4,                      6,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    192,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_letterpotion,           1,                      6,                           2,                     10,                      5,                      7,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    216,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wand,                   1,                      7,                           3,                     11,                      6,                      8,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    144,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_hookshot,               1,                      8,                           4,                      0,                      7,                      9,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    168,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_sbomb,                  1,                      9,                           5,                      1,                      8,                     10,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    192,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_lens,                   1,                     10,                           6,                      2,                      9,                     11,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    216,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_hammer,                 1,                     11,                           7,                      3,                     10,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSELECTOR1,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        },
        {
            //ssdtNEWSUBSCR,      dungeon
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoRECT,                             pos,                      0,           0,         256,          168,            ssctMISC,                  ssctSUBSCRBG,                      ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     68,          18,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "INVENTORY" },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                     12,          34,          14,            6,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLARGEMAP,                         pos,                     96,          82,           0,            0,            ssctMISC,                  ssctBMAPFG,                        ssctMISC,                  ssctLINKDOT,                       0,                         0,                                 1,                            1,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      1,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     52,          90,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "MAP" },
            { ssoTEXT,                             pos,                     52,         130,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "COMPASS" },
            { ssoCURRENTITEM,                      pos,                     44,         106,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_map,                    1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     44,         146,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_compass,                1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    136,          18,          13,            8,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     20,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_raft,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     36,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_book,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     52,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ring,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     68,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ladder,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     84,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_magickey,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    100,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bracelet,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     20,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_shield,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     36,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wallet,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     52,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_amulet,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     68,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_flippers,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     84,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_boots,                  1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    100,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_heartpiece,             1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSELECTOR2,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    188,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    196,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bow,                    1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    144,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_brang,                  1,                      0,                           8,                      4,                     11,                      1,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    168,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bomb,                   1,                      1,                           9,                      5,                      0,                      2,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    192,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  0,                      2,                          10,                      6,                      1,                      3,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    216,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_candle,                 1,                      3,                          11,                      7,                      2,                      4,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    144,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_whistle,                1,                      4,                           0,                      8,                      3,                      5,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    168,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bait,                   1,                      5,                           1,                      9,                      4,                      6,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    192,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_letterpotion,           1,                      6,                           2,                     10,                      5,                      7,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    216,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wand,                   1,                      7,                           3,                     11,                      6,                      8,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    144,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_hookshot,               1,                      8,                           4,                      0,                      7,                      9,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    168,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_sbomb,                  1,                      9,                           5,                      1,                      8,                     10,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    192,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_lens,                   1,                     10,                           6,                      2,                      9,                     11,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    216,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_hammer,                 1,                     11,                           7,                      3,                     10,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSELECTOR1,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        }
    },
    {
        //ssdtREV2
        {
            //ssdtREV2,      overworld
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoRECT,                             pos,                      0,           0,         256,          168,            ssctMISC,                  ssctSUBSCRBG,                      ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     62,          18,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "INVENTORY" },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                      6,          34,          14,            6,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    128,         154,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "TRIFORCE" },
            { ssoTRIFRAME,                         pos,                     80,          98,           0,            0,            ssctMISC,                  ssctTRIFRAMECOLOR,                 ssctMISC,                  ssctCAPTION,                       0,                         0,                                 0,                            0,                      0,                           0,                      1,                      1,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    118,          18,          16,            8,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     14,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_raft,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     30,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_book,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     46,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ring,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     62,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ladder,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     78,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_magickey,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     94,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bracelet,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     14,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_shield,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     30,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wallet,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     46,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_amulet,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     62,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_flippers,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     78,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_boots,                  1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     94,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_heartpiece,             1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSELECTOR2,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    170,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    178,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bow,                    1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    126,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_brang,                  1,                      0,                           8,                      4,                     14,                      1,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    150,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bomb,                   1,                      1,                           9,                      5,                      0,                      2,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    174,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  0,                      2,                          10,                      6,                      1,                      3,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    198,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_candle,                 1,                      3,                          11,                      7,                      2,                     12,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    222,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_dinsfire,               1,                     12,                          14,                     13,                      3,                      4,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    126,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_whistle,                1,                      4,                           0,                      8,                     12,                      5,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    150,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bait,                   1,                      5,                           1,                      9,                      4,                      6,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    174,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_letterpotion,           1,                      6,                           2,                     10,                      5,                      7,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    198,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wand,                   1,                      7,                           3,                     11,                      6,                     13,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    222,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_faroreswind,            1,                     13,                          12,                     14,                      7,                      8,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    126,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_hookshot,               1,                      8,                           4,                      0,                     13,                      9,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    150,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_sbomb,                  1,                      9,                           5,                      1,                      8,                     10,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    174,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_lens,                   1,                     10,                           6,                      2,                      9,                     11,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    198,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_hammer,                 1,                     11,                           7,                      3,                     10,                     14,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    222,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_nayruslove,             1,                     14,                          13,                     12,                     11,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSELECTOR1,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        },
        {
            //ssdtREV2,      dungeon
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoRECT,                             pos,                      0,           0,         256,          168,            ssctMISC,                  ssctSUBSCRBG,                      ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     62,          18,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "INVENTORY" },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                      6,          34,          14,            6,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                     16,          98,           9,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLARGEMAP,                         pos,                     96,          82,           0,            0,            ssctMISC,                  ssctBMAPFG,                        ssctMISC,                  ssctLINKDOT,                       0,                         0,                                 1,                            1,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      1,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     24,         106,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_map,                    1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     44,         106,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_compass,                1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     64,         106,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bosskey,                1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    118,          18,          16,            8,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     14,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_raft,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     30,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_book,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     46,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ring,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     62,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ladder,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     78,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_magickey,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     94,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bracelet,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     14,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_shield,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     30,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wallet,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     46,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_amulet,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     62,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_flippers,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     78,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_boots,                  1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     94,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_heartpiece,             1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSELECTOR2,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    170,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    178,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bow,                    1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    126,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_brang,                  1,                      0,                           8,                      4,                     14,                      1,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    150,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bomb,                   1,                      1,                           9,                      5,                      0,                      2,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    174,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  0,                      2,                          10,                      6,                      1,                      3,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    198,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_candle,                 1,                      3,                          11,                      7,                      2,                     12,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    222,          26,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_dinsfire,               1,                     12,                          14,                     13,                      3,                      4,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    126,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_whistle,                1,                      4,                           0,                      8,                     12,                      5,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    150,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bait,                   1,                      5,                           1,                      9,                      4,                      6,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    174,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_letterpotion,           1,                      6,                           2,                     10,                      5,                      7,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    198,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wand,                   1,                      7,                           3,                     11,                      6,                     13,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    222,          42,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_faroreswind,            1,                     13,                          12,                     14,                      7,                      8,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    126,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_hookshot,               1,                      8,                           4,                      0,                     13,                      9,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    150,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_sbomb,                  1,                      9,                           5,                      1,                      8,                     10,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    174,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_lens,                   1,                     10,                           6,                      2,                      9,                     11,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    198,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_hammer,                 1,                     11,                           7,                      3,                     10,                     14,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    222,          58,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_nayruslove,             1,                     14,                          13,                     12,                     11,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSELECTOR1,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        }
    },
    {
        //ssdtBSZELDA
        {
            //ssdtBSZELDA,      overworld
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoRECT,                             pos,                      0,           0,         256,          168,            ssctMISC,                  ssctSUBSCRBG,                      ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                      0,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        0,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                      8,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        1,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                     88,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        2,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                     96,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        3,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    104,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        4,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    112,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        5,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    120,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        6,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    128,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        7,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    136,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        8,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    144,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        9,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    152,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,       10,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    248,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,       11,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     51,          24,           0,            0,            ssctMISC,                  ssctCAPTION,                       ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "INVENTORY" },
            { sso2X2FRAME,                         pos,                     28,          80,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     40,          80,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWEDU,               0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B" },
            { ssoTEXT,                             pos,                     56,          88,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS2,                       sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B Button" },
            { ssoTEXT,                             pos,                     56,          96,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS2,                       sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "to use item" },
            { sso2X2FRAME,                         pos,                     20,          40,          13,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    136,          48,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS2,                       sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "TRIFORCE" },
            { ssoTRIFRAME,                         pos,                    136,          56,           0,            0,            ssctMISC,                  ssctTRIFRAMECOLOR,                 ssctMISC,                  ssctCAPTION,                       0,                         0,                                 0,                            0,                      0,                           0,                      1,                      1,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                     20,         112,          14,            7,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                     32,          88,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     48,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_raft,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     96,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_book,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     80,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ring,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     32,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ladder,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     64,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bracelet,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSELECTOR2,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     76,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     84,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bow,                    1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     32,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_brang,                  1,                      0,                           4,                      4,                      7,                      1,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     56,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bomb,                   1,                      1,                           5,                      5,                      0,                      2,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     80,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  0,                      2,                           6,                      6,                      1,                      3,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    104,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_candle,                 1,                      3,                           7,                      7,                      2,                      4,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     32,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_whistle,                1,                      4,                           0,                      0,                      3,                      5,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     56,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bait,                   1,                      5,                           1,                      1,                      4,                      6,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     80,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_letterpotion,           1,                      6,                           2,                      2,                      5,                      7,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    104,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wand,                   1,                      7,                           3,                      3,                      6,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBSTIME,                           sspDOWN,                208,          25,            0,           0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaLEFT,               sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoRECT,                             sspDOWN,                160,          25,           44,           7,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctTEXT,                          0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspDOWN,                204,          25,            1,           8,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspDOWN,                160,          32,           45,           1,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             sspDOWN,                161,          26,            0,           0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 ssctSYSTEM,                -1,                                ssfZTIME,                     sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "ZELDA TIME" },
            { ssoSELECTOR1,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        },
        {
            //ssdtBSZELDA,      dungeon
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoRECT,                             pos,                      0,           0,         256,          168,            ssctMISC,                  ssctSUBSCRBG,                      ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                      0,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        0,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                      8,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        1,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                     88,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        2,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                     96,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        3,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    104,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        4,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    112,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        5,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    120,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        6,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    128,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        7,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    136,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        8,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    144,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        9,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    152,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,       10,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    248,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,       11,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     51,          24,           0,            0,            ssctMISC,                  ssctCAPTION,                       ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "INVENTORY" },
            { sso2X2FRAME,                         pos,                     28,          80,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     40,          80,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWEDU,               0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B" },
            { ssoTEXT,                             pos,                     56,          88,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS2,                       sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B Button" },
            { ssoTEXT,                             pos,                     56,          96,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS2,                       sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "to use item" },
            { sso2X2FRAME,                         pos,                     20,          40,          13,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    160,          40,           4,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    192,          40,           4,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLARGEMAP,                         pos,                    144,          88,           0,            0,            ssctMISC,                  ssctBMAPFG,                        ssctMISC,                  ssctLINKDOT,                       0,                         0,                                 1,                            1,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    176,          72,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "Compass" },
            { ssoTEXT,                             pos,                    208,          72,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "Map" },
            { ssoCURRENTITEM,                      pos,                    200,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_map,                    1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    168,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_compass,                1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                     20,         112,          14,            7,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                     32,          88,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     48,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_raft,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     96,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_book,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     80,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ring,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     32,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ladder,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     64,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bracelet,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSELECTOR2,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     76,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     84,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bow,                    1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     32,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_brang,                  1,                      0,                           4,                      4,                      7,                      1,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     56,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bow,                    1,                      1,                           5,                      5,                      0,                      2,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     80,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  0,                      2,                           6,                      6,                      1,                      3,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    104,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_candle,                 1,                      3,                           7,                      7,                      2,                      4,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     32,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_whistle,                1,                      4,                           0,                      0,                      3,                      5,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     56,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bait,                   1,                      5,                           1,                      1,                      4,                      6,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     80,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_letterpotion,           1,                      6,                           2,                      2,                      5,                      7,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    104,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wand,                   1,                      7,                           3,                      3,                      6,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBSTIME,                           sspDOWN,                208,          25,            0,           0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaLEFT,               sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoRECT,                             sspDOWN,                160,          25,           44,           7,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctTEXT,                          0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspDOWN,                204,          25,            1,           8,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspDOWN,                160,          32,           45,           1,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             sspDOWN,                161,          26,            0,           0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 ssctSYSTEM,                -1,                                ssfZTIME,                     sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "ZELDA TIME" },
            { ssoSELECTOR1,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        }
    },
    {
        //ssdtBSZELDAMODIFIED
        {
            //ssdtBSZELDAMODIFIED,      overworld
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoRECT,                             pos,                      0,           0,         256,          168,            ssctMISC,                  ssctSUBSCRBG,                      ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                      0,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        0,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                      8,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        1,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                     88,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        2,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                     96,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        3,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    104,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        4,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    112,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        5,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    120,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        6,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    128,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        7,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    136,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        8,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    144,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        9,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    152,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,       10,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    248,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,       11,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     51,          24,           0,            0,            ssctMISC,                  ssctCAPTION,                       ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "INVENTORY" },
            { sso2X2FRAME,                         pos,                     28,          80,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     40,          80,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWEDU,               0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B" },
            { ssoTEXT,                             pos,                     56,          88,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS2,                       sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B Button" },
            { ssoTEXT,                             pos,                     56,          96,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS2,                       sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "to use item" },
            { sso2X2FRAME,                         pos,                     12,          40,          15,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    136,          48,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS2,                       sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "TRIFORCE" },
            { ssoTRIFRAME,                         pos,                    136,          56,           0,            0,            ssctMISC,                  ssctTRIFRAMECOLOR,                 ssctMISC,                  ssctCAPTION,                       0,                         0,                                 0,                            0,                      0,                           0,                      1,                      1,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                     20,         112,          14,            7,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                     32,          88,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     40,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_raft,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     88,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_book,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     72,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ring,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     24,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ladder,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    104,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_magickey,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     56,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bracelet,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSELECTOR2,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     76,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     84,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bow,                    1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     32,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_brang,                  1,                      0,                           4,                      4,                      7,                      1,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     56,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bomb,                   1,                      1,                           5,                      5,                      0,                      2,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     80,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  0,                      2,                           6,                      6,                      1,                      3,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    104,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_candle,                 1,                      3,                           7,                      7,                      2,                      4,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     32,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_whistle,                1,                      4,                           0,                      0,                      3,                      5,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     56,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bait,                   1,                      5,                           1,                      1,                      4,                      6,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     80,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_letterpotion,           1,                      6,                           2,                      2,                      5,                      7,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    104,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wand,                   1,                      7,                           3,                      3,                      6,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBSTIME,                           sspDOWN,                208,          25,            0,           0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaLEFT,               sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoRECT,                             sspDOWN,                160,          25,           44,           7,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctTEXT,                          0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspDOWN,                204,          25,            1,           8,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspDOWN,                160,          32,           45,           1,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             sspDOWN,                161,          26,            0,           0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 ssctSYSTEM,                -1,                                ssfZTIME,                     sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "ZELDA TIME" },
            { ssoSELECTOR1,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        },
        {
            //ssdtBSZELDAMODIFIED,      dungeon
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoRECT,                             pos,                      0,           0,         256,          168,            ssctMISC,                  ssctSUBSCRBG,                      ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                      0,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        0,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                      8,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        1,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                     88,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        2,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                     96,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        3,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    104,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        4,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    112,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        5,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    120,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        6,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    128,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        7,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    136,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        8,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    144,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        9,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    152,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,       10,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    248,          24,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,       11,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     51,          24,           0,            0,            ssctMISC,                  ssctCAPTION,                       ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "INVENTORY" },
            { sso2X2FRAME,                         pos,                     28,          80,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     40,          80,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWEDU,               0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B" },
            { ssoTEXT,                             pos,                     56,          88,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS2,                       sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B Button" },
            { ssoTEXT,                             pos,                     56,          96,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS2,                       sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "to use item" },
            { sso2X2FRAME,                         pos,                     12,          40,          15,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    160,          40,           4,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    192,          40,           4,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLARGEMAP,                         pos,                    144,          88,           0,            0,            ssctMISC,                  ssctBMAPFG,                        ssctMISC,                  ssctLINKDOT,                       0,                         0,                                 1,                            1,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    176,          72,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "Compass" },
            { ssoTEXT,                             pos,                    208,          72,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "Map" },
            { ssoCURRENTITEM,                      pos,                    200,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_map,                    1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    168,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_compass,                1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                     20,         112,          14,            7,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                     32,          88,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     40,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_raft,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     88,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_book,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     72,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ring,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     24,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ladder,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    104,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_magickey,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     56,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bracelet,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSELECTOR2,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     76,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     84,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bow,                    1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     32,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_brang,                  1,                      0,                           4,                      4,                      7,                      1,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     56,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bomb,                   1,                      1,                           5,                      5,                      0,                      2,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     80,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  0,                      2,                           6,                      6,                      1,                      3,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    104,         120,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_candle,                 1,                      3,                           7,                      7,                      2,                      4,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     32,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_whistle,                1,                      4,                           0,                      0,                      3,                      5,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     56,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bait,                   1,                      5,                           1,                      1,                      4,                      6,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     80,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_letterpotion,           1,                      6,                           2,                      2,                      5,                      7,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    104,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wand,                   1,                      7,                           3,                      3,                      6,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBSTIME,                           sspDOWN,                208,          25,            0,           0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaLEFT,               sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoRECT,                             sspDOWN,                160,          25,           44,           7,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctTEXT,                          0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspDOWN,                204,          25,            1,           8,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspDOWN,                160,          32,           45,           1,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             sspDOWN,                161,          26,            0,           0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 ssctSYSTEM,                -1,                                ssfZTIME,                     sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "ZELDA TIME" },
            { ssoSELECTOR1,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        }
    },
    {
        //ssdtBSZELDAENHANCED
        {
            //ssdtBSZELDAENHANCED,      overworld
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoRECT,                             pos,                      0,           0,         256,          168,            ssctMISC,                  ssctSUBSCRBG,                      ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                      0,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        0,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                      8,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        1,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                     88,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        2,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                     96,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        3,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    104,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        4,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    112,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        5,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    120,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        6,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    128,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        7,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    136,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        8,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    144,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        9,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    152,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,       10,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    248,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,       11,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     51,           8,           0,            0,            ssctMISC,                  ssctCAPTION,                       ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "INVENTORY" },
            { sso2X2FRAME,                         pos,                     28,          72,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     40,          72,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWEDU,               0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B" },
            { ssoTEXT,                             pos,                     56,          80,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS2,                       sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B Button" },
            { ssoTEXT,                             pos,                     56,          88,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS2,                       sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "to use item" },
            { sso2X2FRAME,                         pos,                     12,          20,          15,            6,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    136,          48,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS2,                       sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "TRIFORCE" },
            { ssoTRIFRAME,                         pos,                    136,          56,           0,            0,            ssctMISC,                  ssctTRIFRAMECOLOR,                 ssctMISC,                  ssctCAPTION,                       0,                         0,                                 0,                            0,                      0,                           0,                      1,                      1,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                     20,         104,          14,            8,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                     32,          80,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     40,          28,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_raft,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     88,          28,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_book,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     72,          28,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ring,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     24,          28,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ladder,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    104,          28,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_magickey,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     56,          28,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bracelet,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     24,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_shield,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     40,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wallet,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     56,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_amulet,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     72,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_flippers,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     88,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_boots,                  1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    104,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_heartpiece,             1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSELECTOR2,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     76,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     84,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bow,                    1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     32,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_brang,                  1,                      0,                           8,                      4,                     11,                      1,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     56,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bomb,                   1,                      1,                           9,                      5,                      0,                      2,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     80,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  0,                      2,                          10,                      6,                      1,                      3,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    104,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_candle,                 1,                      3,                          11,                      7,                      2,                      4,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     32,         128,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_whistle,                1,                      4,                           0,                      8,                      3,                      5,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     56,         128,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bait,                   1,                      5,                           1,                      9,                      4,                      6,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     80,         128,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_letterpotion,           1,                      6,                           2,                     10,                      5,                      7,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    104,         128,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wand,                   1,                      7,                           3,                     11,                      6,                      8,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     32,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_hookshot,               1,                      8,                           4,                      0,                      7,                      9,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     56,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_sbomb,                  1,                      9,                           5,                      1,                      8,                     10,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     80,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_lens,                   1,                     10,                           6,                      2,                      9,                     11,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    104,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_hammer,                 1,                     11,                           7,                      3,                     10,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBSTIME,                           sspDOWN,                208,           9,            0,           0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaLEFT,               sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoRECT,                             sspDOWN,                160,           9,           44,           7,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctTEXT,                          0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspDOWN,                204,           9,            1,           8,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspDOWN,                160,          16,           45,           1,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             sspDOWN,                161,          10,            0,           0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 ssctSYSTEM,                -1,                                ssfZTIME,                     sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "ZELDA TIME" },
            { ssoSELECTOR1,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        },
        {
            //ssdtBSZELDAENHANCED,      dungeon
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoRECT,                             pos,                      0,           0,         256,          168,            ssctMISC,                  ssctSUBSCRBG,                      ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                      0,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        0,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                      8,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        1,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                     88,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        2,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                     96,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        3,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    104,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        4,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    112,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        5,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    120,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        6,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    128,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        7,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    136,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        8,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    144,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        9,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    152,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,       10,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    248,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,       11,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     51,           8,           0,            0,            ssctMISC,                  ssctCAPTION,                       ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "INVENTORY" },
            { sso2X2FRAME,                         pos,                     28,          72,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     40,          72,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWEDU,               0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B" },
            { ssoTEXT,                             pos,                     56,          80,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS2,                       sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B Button" },
            { ssoTEXT,                             pos,                     56,          88,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS2,                       sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "to use item" },
            { sso2X2FRAME,                         pos,                     12,          20,          15,            6,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    160,          40,           4,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    192,          40,           4,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLARGEMAP,                         pos,                    144,          88,           0,            0,            ssctMISC,                  ssctBMAPFG,                        ssctMISC,                  ssctLINKDOT,                       0,                         0,                                 1,                            1,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    176,          72,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "Compass" },
            { ssoTEXT,                             pos,                    208,          72,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "Map" },
            { ssoCURRENTITEM,                      pos,                    200,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_map,                    1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    168,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_compass,                1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                     20,         104,          14,            8,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                     32,          80,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     40,          28,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_raft,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     88,          28,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_book,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     72,          28,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ring,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     24,          28,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ladder,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    104,          28,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_magickey,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     56,          28,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bracelet,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     24,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_shield,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     40,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wallet,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     56,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_amulet,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     72,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_flippers,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     88,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_boots,                  1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    104,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_heartpiece,             1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSELECTOR2,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     76,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     84,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bow,                    1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     32,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_brang,                  1,                      0,                           8,                      4,                     11,                      1,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     56,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bomb,                   1,                      1,                           9,                      5,                      0,                      2,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     80,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  0,                      2,                          10,                      6,                      1,                      3,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    104,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_candle,                 1,                      3,                          11,                      7,                      2,                      4,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     32,         128,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_whistle,                1,                      4,                           0,                      8,                      3,                      5,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     56,         128,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bait,                   1,                      5,                           1,                      9,                      4,                      6,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     80,         128,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_letterpotion,           1,                      6,                           2,                     10,                      5,                      7,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    104,         128,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wand,                   1,                      7,                           3,                     11,                      6,                      8,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     32,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_hookshot,               1,                      8,                           4,                      0,                      7,                      9,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     56,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_sbomb,                  1,                      9,                           5,                      1,                      8,                     10,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     80,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_lens,                   1,                     10,                           6,                      2,                      9,                     11,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    104,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_hammer,                 1,                     11,                           7,                      3,                     10,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBSTIME,                           sspDOWN,                208,           9,            0,           0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaLEFT,               sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoRECT,                             sspDOWN,                160,           9,           44,           7,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctTEXT,                          0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspDOWN,                204,           9,            1,           8,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspDOWN,                160,          16,           45,           1,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             sspDOWN,                161,          10,            0,           0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 ssctSYSTEM,                -1,                                ssfZTIME,                     sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "ZELDA TIME" },
            { ssoSELECTOR1,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        }
    },
    {
        //ssdtBSZELDACOMPLETE
        {
            //ssdtBSZELDACOMPLETE,      overworld
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoRECT,                             pos,                      0,           0,         256,          168,            ssctMISC,                  ssctSUBSCRBG,                      ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                      0,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        0,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                      8,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        1,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                     88,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        2,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                     96,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        3,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    104,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        4,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    112,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        5,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    120,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        6,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    128,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        7,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    136,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        8,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    144,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        9,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    152,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,       10,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    248,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,       11,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     51,           8,           0,            0,            ssctMISC,                  ssctCAPTION,                       ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "INVENTORY" },
            { sso2X2FRAME,                         pos,                     28,          72,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     40,          72,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWEDU,               0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B" },
            { ssoTEXT,                             pos,                     56,          80,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS2,                       sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B Button" },
            { ssoTEXT,                             pos,                     56,          88,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS2,                       sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "to use item" },
            { sso2X2FRAME,                         pos,                     12,          20,          15,            6,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    136,          48,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS2,                       sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "TRIFORCE" },
            { ssoTRIFRAME,                         pos,                    136,          56,           0,            0,            ssctMISC,                  ssctTRIFRAMECOLOR,                 ssctMISC,                  ssctCAPTION,                       0,                         0,                                 0,                            0,                      0,                           0,                      1,                      1,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                      4,         104,          16,            8,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                     32,          80,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     40,          28,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_raft,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     88,          28,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_book,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     72,          28,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ring,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     24,          28,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ladder,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    104,          28,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_magickey,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     56,          28,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bracelet,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     24,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_shield,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     40,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wallet,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     56,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_amulet,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     72,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_flippers,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     88,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_boots,                  1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    104,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_heartpiece,             1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSELECTOR2,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     58,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     68,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bow,                    1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     14,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_brang,                  1,                      0,                           8,                      4,                     14,                      1,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     38,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bomb,                   1,                      1,                           9,                      5,                      0,                      2,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     62,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  0,                      2,                          10,                      6,                      1,                      3,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     86,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_candle,                 1,                      3,                          11,                      7,                      2,                     12,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    110,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_dinsfire,               1,                     12,                          14,                     13,                      3,                      4,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     14,         128,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_whistle,                1,                      4,                           0,                      8,                     12,                      5,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     38,         128,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bait,                   1,                      5,                           1,                      9,                      4,                      6,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     62,         128,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_letterpotion,           1,                      6,                           2,                     10,                      5,                      7,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     86,         128,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wand,                   1,                      7,                           3,                     11,                      6,                     13,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    110,         128,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_faroreswind,            1,                     13,                          12,                     14,                      7,                      8,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     14,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_hookshot,               1,                      8,                           4,                      0,                     13,                      9,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     38,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_sbomb,                  1,                      9,                           5,                      1,                      8,                     10,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     62,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_lens,                   1,                     10,                           6,                      2,                      9,                     11,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     86,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_hammer,                 1,                     11,                           7,                      3,                     10,                     14,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    110,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_nayruslove,             1,                     14,                          13,                     12,                     11,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBSTIME,                           sspDOWN,                208,           9,            0,           0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaLEFT,               sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoRECT,                             sspDOWN,                160,           9,           44,           7,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctTEXT,                          0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspDOWN,                204,           9,            1,           8,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspDOWN,                160,          16,           45,           1,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             sspDOWN,                161,          10,            0,           0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 ssctSYSTEM,                -1,                                ssfZTIME,                     sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "ZELDA TIME" },
            { ssoSELECTOR1,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        },
        {
            //ssdtBSZELDACOMPLETE,      dungeon
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoRECT,                             pos,                      0,           0,         256,          168,            ssctMISC,                  ssctSUBSCRBG,                      ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                      0,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        0,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                      8,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        1,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                     88,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        2,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                     96,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        3,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    104,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        4,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    112,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        5,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    120,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        6,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    128,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        7,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    136,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        8,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    144,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,        9,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    152,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,       10,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINITILE,                         pos,                    248,           8,           0,            0,            ssctMISC,                  sscsSSVINECSET,                    0,                         0,                                 0,                         0,                                 -1,                           ssmstSSVINETILE,       11,                           0,                      1,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     51,           8,           0,            0,            ssctMISC,                  ssctCAPTION,                       ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "INVENTORY" },
            { sso2X2FRAME,                         pos,                     28,          72,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                     40,          72,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWEDU,               0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B" },
            { ssoTEXT,                             pos,                     56,          80,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS2,                       sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B Button" },
            { ssoTEXT,                             pos,                     56,          88,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfSS2,                       sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "to use item" },
            { sso2X2FRAME,                         pos,                     12,          20,          15,            6,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    152,          40,          10,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLARGEMAP,                         pos,                    144,          88,           0,            0,            ssctMISC,                  ssctBMAPFG,                        ssctMISC,                  ssctLINKDOT,                       0,                         0,                                 1,                            1,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    160,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_map,                    1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    184,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_compass,                1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    208,          48,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bosskey,                1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                      4,         104,          16,            8,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                     32,          80,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     40,          28,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_raft,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     88,          28,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_book,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     72,          28,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ring,                   1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     24,          28,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_ladder,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    104,          28,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_magickey,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     56,          28,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bracelet,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     24,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_shield,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     40,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wallet,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     56,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_amulet,                 1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     72,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_flippers,               1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     88,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_boots,                  1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    104,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_heartpiece,             1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSELECTOR2,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     58,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     68,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bow,                    1,                      -1,                          0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     14,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_brang,                  1,                      0,                           8,                      4,                     14,                      1,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     38,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bomb,                   1,                      1,                           9,                      5,                      0,                      2,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     62,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_arrow,                  0,                      2,                          10,                      6,                      1,                      3,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     86,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_candle,                 1,                      3,                          11,                      7,                      2,                     12,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    110,         112,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_dinsfire,               1,                     12,                          14,                     13,                      3,                      4,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     14,         128,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_whistle,                1,                      4,                           0,                      8,                     12,                      5,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     38,         128,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_bait,                   1,                      5,                           1,                      9,                      4,                      6,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     62,         128,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_letterpotion,           1,                      6,                           2,                     10,                      5,                      7,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     86,         128,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_wand,                   1,                      7,                           3,                     11,                      6,                     13,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    110,         128,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_faroreswind,            1,                     13,                          12,                     14,                      7,                      8,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     14,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_hookshot,               1,                      8,                           4,                      0,                     13,                      9,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     38,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_sbomb,                  1,                      9,                           5,                      1,                      8,                     10,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     62,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_lens,                   1,                     10,                           6,                      2,                      9,                     11,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                     86,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_hammer,                 1,                     11,                           7,                      3,                     10,                     14,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCURRENTITEM,                      pos,                    110,         144,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 itype_nayruslove,             1,                     14,                          13,                     12,                     11,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBSTIME,                           sspDOWN,                208,           9,            0,           0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaLEFT,               sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoRECT,                             sspDOWN,                160,           9,           44,           7,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctTEXT,                          0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspDOWN,                204,           9,            1,           8,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspDOWN,                160,          16,           45,           1,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             sspDOWN,                161,          10,            0,           0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 ssctSYSTEM,                -1,                                ssfZTIME,                     sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "ZELDA TIME" },
            { ssoSELECTOR1,                        pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        }
    }
};
subscreen_object default_subscreen_passive[ssdtMAX][2][21]= //[zinit.subscreen][no magic]
{
    {
        //ssdtOLD
        {
            //ssdtOLD,      magic
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoCLEAR,                            pos,                      0,           0,           0,            0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAP,                          pos,                      8,           8,           0,            0,            ssctMISC,                  ssctLINKDOT,                       ssctMISC,                  ssctCOMPASSLT,                     ssctMISC,                  ssctCOMPASSDK,                     1,                            1,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAPTITLE,                     pos,                     48,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCOUNTERS,                         pos,                     88,          16,          32,           32,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     1,                      sstsNORMAL,                  3,                      'A',                    0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSSTIME,                           pos,                    240,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaRIGHT,              sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    120,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    144,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       sspUP,                  124,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       sspUP,                  148,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    132,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctMISC,                  ssctSUBSCRBG,                      ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B" },
            { ssoTEXT,                             pos,                    156,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctMISC,                  ssctSUBSCRBG,                      ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "A" },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    208,          12,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "-LIFE-" },
            { ssoLIFEMETER,                        pos,                    176,          12,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMAGICMETER,                       pos,                    176,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        },
        {
            //ssdtOLD,      no magic
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoCLEAR,                            pos,                      0,           0,           0,            0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAP,                          pos,                      8,           8,           0,            0,            ssctMISC,                  ssctLINKDOT,                       ssctMISC,                  ssctCOMPASSLT,                     ssctMISC,                  ssctCOMPASSDK,                     1,                            1,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAPTITLE,                     pos,                     48,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCOUNTERS,                         pos,                     88,          16,          32,           32,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     1,                      sstsNORMAL,                  3,                      'A',                    0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSSTIME,                           pos,                    240,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaRIGHT,              sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    120,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    144,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       sspUP,                  124,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       sspUP,                  148,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    132,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctMISC,                  ssctSUBSCRBG,                      ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B" },
            { ssoTEXT,                             pos,                    156,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctMISC,                  ssctSUBSCRBG,                      ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "A" },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    208,          16,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "-LIFE-" },
            { ssoLIFEMETER,                        pos,                    176,          16,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        }
    },
    {
        //ssdtNEWSUBSCR
        {
            //ssdtNEWSUBSCR,      magic
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoCLEAR,                            pos,                      0,           0,           0,            0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAP,                          pos,                      8,           8,           0,            0,            ssctMISC,                  ssctLINKDOT,                       ssctMISC,                  ssctCOMPASSLT,                     ssctMISC,                  ssctCOMPASSDK,                     1,                            1,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAPTITLE,                     pos,                     48,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCOUNTERS,                         pos,                     88,          16,          32,           32,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     1,                      sstsNORMAL,                  3,                      'A',                    0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSSTIME,                           pos,                    240,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaRIGHT,              sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    120,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    144,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                    124,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                    148,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    132,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctMISC,                  ssctSUBSCRBG,                      ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B" },
            { ssoTEXT,                             pos,                    156,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctMISC,                  ssctSUBSCRBG,                      ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "A" },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    208,          12,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "-LIFE-" },
            { ssoLIFEMETER,                        pos,                    176,          12,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMAGICMETER,                       pos,                    176,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        },
        {
            //ssdtNEWSUBSCR,      no magic
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoCLEAR,                            pos,                      0,           0,           0,            0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAP,                          pos,                      8,           8,           0,            0,            ssctMISC,                  ssctLINKDOT,                       ssctMISC,                  ssctCOMPASSLT,                     ssctMISC,                  ssctCOMPASSDK,                     1,                            1,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAPTITLE,                     pos,                     48,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCOUNTERS,                         pos,                     88,          16,          32,           32,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     1,                      sstsNORMAL,                  3,                      'A',                    0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSSTIME,                           pos,                    240,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaRIGHT,              sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    120,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    144,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                    124,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                    148,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    132,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctMISC,                  ssctSUBSCRBG,                      ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B" },
            { ssoTEXT,                             pos,                    156,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctMISC,                  ssctSUBSCRBG,                      ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "A" },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    208,          16,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "-LIFE-" },
            { ssoLIFEMETER,                        pos,                    176,          16,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        }
    },
    {
        //ssdtREV2
        {
            //ssdtREV2,      magic
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoCLEAR,                            pos,                      0,           0,           0,            0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAP,                          pos,                      8,           8,           0,            0,            ssctMISC,                  ssctLINKDOT,                       ssctMISC,                  ssctCOMPASSLT,                     ssctMISC,                  ssctCOMPASSDK,                     1,                            1,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAPTITLE,                     pos,                     48,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCOUNTERS,                         pos,                     88,          16,          32,           32,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     1,                      sstsNORMAL,                  3,                      'A',                    0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSSTIME,                           pos,                    240,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaRIGHT,              sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    120,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    144,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                    124,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                    148,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    132,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctMISC,                  ssctSUBSCRBG,                      ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B" },
            { ssoTEXT,                             pos,                    156,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctMISC,                  ssctSUBSCRBG,                      ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "A" },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    208,          12,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "-LIFE-" },
            { ssoLIFEMETER,                        pos,                    176,          12,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMAGICMETER,                       pos,                    176,          44,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        },
        {
            //ssdtREV2,      no magic
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoCLEAR,                            pos,                      0,           0,           0,            0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAP,                          pos,                      8,           8,           0,            0,            ssctMISC,                  ssctLINKDOT,                       ssctMISC,                  ssctCOMPASSLT,                     ssctMISC,                  ssctCOMPASSDK,                     1,                            1,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAPTITLE,                     pos,                     48,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 0,                         0,                                 ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCOUNTERS,                         pos,                     88,          16,          32,           32,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     1,                      sstsNORMAL,                  3,                      'A',                    0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSSTIME,                           pos,                    240,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaRIGHT,              sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    120,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    144,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                    124,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                    148,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    132,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctMISC,                  ssctSUBSCRBG,                      ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B" },
            { ssoTEXT,                             pos,                    156,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctMISC,                  ssctSUBSCRBG,                      ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "A" },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    208,          16,           0,            0,            ssctMISC,                  ssctCAPTION,                       0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaCENTER,             sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "-LIFE-" },
            { ssoLIFEMETER,                        pos,                    176,          16,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        }
    },
    {
        //ssdtBSZELDA
        {
            //ssdtBSZELDA,      magic
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoCLEAR,                            pos,                      0,           0,           0,            0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAP,                          pos,                      8,           8,           0,            0,            ssctMISC,                  ssctLINKDOT,                       ssctMISC,                  ssctCOMPASSLT,                     ssctMISC,                  ssctCOMPASSDK,                     1,                            1,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAPTITLE,                     pos,                     48,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS3,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCOUNTERS,                         pos,                     88,          16,          32,           32,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       1,                      sstsSHADOWED,                4,                      '~',                    0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSSTIME,                           pos,                    240,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaRIGHT,              sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    132,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    156,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                    136,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                    160,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    144,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWEDU,               0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B" },
            { ssoTEXT,                             pos,                    168,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsOUTLINED8,               0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "A" },
            { ssoLINE,                             pos,                    163,          15,         174,            1,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    220,           8,           0,            0,            ssctMISC,                  ssctCAPTION,                       ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "-  life  -" },
            { ssoLIFEMETER,                        pos,                    188,          16,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            1,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMAGICMETER,                       pos,                    188,          40,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBSTIME,                           sspUP,                  208,          48,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaLEFT,               sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoRECT,                             sspUP,                  160,          48,          44,            7,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctTEXT,                          0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspUP,                  204,          48,           1,            8,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspUP,                  160,          55,          45,            1,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             sspUP,                  161,          49,           0,            0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 ssctSYSTEM,                -1,                                ssfZTIME,                     sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "ZELDA TIME" },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        },
        {
            //ssdtBSZELDA,      no magic
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoCLEAR,                            pos,                      0,           0,           0,            0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAP,                          pos,                      8,           8,           0,            0,            ssctMISC,                  ssctLINKDOT,                       ssctMISC,                  ssctCOMPASSLT,                     ssctMISC,                  ssctCOMPASSDK,                     1,                            1,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAPTITLE,                     pos,                     48,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS3,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCOUNTERS,                         pos,                     88,          16,          32,           32,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       1,                      sstsSHADOWED,                4,                      '~',                    0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSSTIME,                           pos,                    240,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaRIGHT,              sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    132,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    156,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                    136,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                    160,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    144,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWEDU,               0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B" },
            { ssoTEXT,                             pos,                    168,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsOUTLINED8,               0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "A" },
            { ssoLINE,                             pos,                    163,          15,         174,            1,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    216,          16,           0,            0,            ssctMISC,                  ssctCAPTION,                       ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "-  life  -" },
            { ssoLIFEMETER,                        pos,                    184,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            1,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBSTIME,                           sspUP,                  208,          48,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaLEFT,               sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoRECT,                             sspUP,                  160,          48,          44,            7,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctTEXT,                          0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspUP,                  204,          48,           1,            8,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspUP,                  160,          55,          45,            1,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             sspUP,                  161,          49,           0,            0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 ssctSYSTEM,                -1,                                ssfZTIME,                     sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "ZELDA TIME" },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        }
    },
    {
        //ssdtBSZELDAMODIFIED
        {
            //ssdtBSZELDAMODIFIED,      magic
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoCLEAR,                            pos,                      0,           0,           0,            0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAP,                          pos,                      8,           8,           0,            0,            ssctMISC,                  ssctLINKDOT,                       ssctMISC,                  ssctCOMPASSLT,                     ssctMISC,                  ssctCOMPASSDK,                     1,                            1,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAPTITLE,                     pos,                     48,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS3,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCOUNTERS,                         pos,                     88,          16,          32,           32,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       1,                      sstsSHADOWED,                4,                      '~',                    0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSSTIME,                           pos,                    240,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaRIGHT,              sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    132,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    156,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                    136,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                    160,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    144,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWEDU,               0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B" },
            { ssoTEXT,                             pos,                    168,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsOUTLINED8,               0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "A" },
            { ssoLINE,                             pos,                    163,          15,         174,            1,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    220,           8,           0,            0,            ssctMISC,                  ssctCAPTION,                       ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "-  life  -" },
            { ssoLIFEMETER,                        pos,                    188,          16,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            1,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMAGICMETER,                       pos,                    188,          40,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBSTIME,                           sspUP,                  208,          48,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaLEFT,               sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoRECT,                             sspUP,                  160,          48,          44,            7,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctTEXT,                          0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspUP,                  204,          48,           1,            8,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspUP,                  160,          55,          45,            1,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             sspUP,                  161,          49,           0,            0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 ssctSYSTEM,                -1,                                ssfZTIME,                     sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "ZELDA TIME" },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        },
        {
            //ssdtBSZELDAMODIFIED,      no magic
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoCLEAR,                            pos,                      0,           0,           0,            0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAP,                          pos,                      8,           8,           0,            0,            ssctMISC,                  ssctLINKDOT,                       ssctMISC,                  ssctCOMPASSLT,                     ssctMISC,                  ssctCOMPASSDK,                     1,                            1,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAPTITLE,                     pos,                     48,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS3,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCOUNTERS,                         pos,                     88,          16,          32,           32,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       1,                      sstsSHADOWED,                4,                      '~',                    0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSSTIME,                           pos,                    240,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaRIGHT,              sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    132,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    156,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                    136,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                    160,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    144,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWEDU,               0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B" },
            { ssoTEXT,                             pos,                    168,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsOUTLINED8,               0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "A" },
            { ssoLINE,                             pos,                    163,          15,         174,            1,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    216,          16,           0,            0,            ssctMISC,                  ssctCAPTION,                       ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "-  life  -" },
            { ssoLIFEMETER,                        pos,                    184,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            1,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBSTIME,                           sspUP,                  208,          48,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaLEFT,               sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoRECT,                             sspUP,                  160,          48,          44,            7,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctTEXT,                          0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspUP,                  204,          48,           1,            8,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspUP,                  160,          55,          45,            1,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             sspUP,                  161,          49,           0,            0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 ssctSYSTEM,                -1,                                ssfZTIME,                     sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "ZELDA TIME" },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        }
    },
    {
        //ssdtBSZELDAENHANCED
        {
            //ssdtBSZELDAENHANCED,      magic
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoCLEAR,                            pos,                      0,           0,           0,            0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAP,                          pos,                      8,           8,           0,            0,            ssctMISC,                  ssctLINKDOT,                       ssctMISC,                  ssctCOMPASSLT,                     ssctMISC,                  ssctCOMPASSDK,                     1,                            1,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAPTITLE,                     pos,                     48,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS3,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCOUNTERS,                         pos,                     88,          16,          32,           32,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       1,                      sstsSHADOWED,                4,                      '~',                    0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSSTIME,                           pos,                    240,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaRIGHT,              sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    132,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    156,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                    136,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                    160,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    144,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWEDU,               0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B" },
            { ssoTEXT,                             pos,                    168,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsOUTLINED8,               0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "A" },
            { ssoLINE,                             pos,                    163,          15,         174,            1,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    220,           8,           0,            0,            ssctMISC,                  ssctCAPTION,                       ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "-  life  -" },
            { ssoLIFEMETER,                        pos,                    188,          16,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            1,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMAGICMETER,                       pos,                    188,          40,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBSTIME,                           sspUP,                  208,          48,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaLEFT,               sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoRECT,                             sspUP,                  160,          48,          44,            7,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctTEXT,                          0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspUP,                  204,          48,           1,            8,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspUP,                  160,          55,          45,            1,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             sspUP,                  161,          49,           0,            0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 ssctSYSTEM,                -1,                                ssfZTIME,                     sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "ZELDA TIME" },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        },
        {
            //ssdtBSZELDAENHANCED,      no magic
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoCLEAR,                            pos,                      0,           0,           0,            0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAP,                          pos,                      8,           8,           0,            0,            ssctMISC,                  ssctLINKDOT,                       ssctMISC,                  ssctCOMPASSLT,                     ssctMISC,                  ssctCOMPASSDK,                     1,                            1,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAPTITLE,                     pos,                     48,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS3,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCOUNTERS,                         pos,                     88,          16,          32,           32,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       1,                      sstsSHADOWED,                4,                      '~',                    0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSSTIME,                           pos,                    240,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaRIGHT,              sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    132,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    156,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                    136,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                    160,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    144,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWEDU,               0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B" },
            { ssoTEXT,                             pos,                    168,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsOUTLINED8,               0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "A" },
            { ssoLINE,                             pos,                    163,          15,         174,            1,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    216,          16,           0,            0,            ssctMISC,                  ssctCAPTION,                       ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "-  life  -" },
            { ssoLIFEMETER,                        pos,                    184,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            1,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBSTIME,                           sspUP,                  208,          48,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaLEFT,               sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoRECT,                             sspUP,                  160,          48,          44,            7,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctTEXT,                          0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspUP,                  204,          48,           1,            8,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspUP,                  160,          55,          45,            1,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             sspUP,                  161,          49,           0,            0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 ssctSYSTEM,                -1,                                ssfZTIME,                     sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "ZELDA TIME" },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        }
    },
    {
        //ssdtBSZELDACOMPLETE
        {
            //ssdtBSZELDACOMPLETE,      magic
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoCLEAR,                            pos,                      0,           0,           0,            0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAP,                          pos,                      8,           8,           0,            0,            ssctMISC,                  ssctLINKDOT,                       ssctMISC,                  ssctCOMPASSLT,                     ssctMISC,                  ssctCOMPASSDK,                     1,                            1,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAPTITLE,                     pos,                     48,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS3,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCOUNTERS,                         pos,                     88,          16,          32,           32,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       1,                      sstsSHADOWED,                4,                      '~',                    0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSSTIME,                           pos,                    240,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaRIGHT,              sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    132,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    156,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                    136,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                    160,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    144,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWEDU,               0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B" },
            { ssoTEXT,                             pos,                    168,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsOUTLINED8,               0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "A" },
            { ssoLINE,                             pos,                    163,          15,         174,            1,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    220,           8,           0,            0,            ssctMISC,                  ssctCAPTION,                       ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "-  life  -" },
            { ssoLIFEMETER,                        pos,                    188,          16,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            1,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMAGICMETER,                       pos,                    188,          40,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBSTIME,                           sspUP,                  208,          48,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaLEFT,               sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoRECT,                             sspUP,                  160,          48,          44,            7,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctTEXT,                          0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspUP,                  204,          48,           1,            8,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspUP,                  160,          55,          45,            1,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             sspUP,                  161,          49,           0,            0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 ssctSYSTEM,                -1,                                ssfZTIME,                     sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "ZELDA TIME" },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL }
        },
        {
            //ssdtBSZELDACOMPLETE,      no magic
            //object                          position             x       y       w        h        color type 1          color 1                       color type 2          color 2                       color type 3          color 3                       d1                       d2                 d3                      d4                 d5                 d6                 d7                 d8                 d9                 d10                frames    speed    delay    frame     dp1
            { ssoCLEAR,                            pos,                      0,           0,           0,            0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAP,                          pos,                      8,           8,           0,            0,            ssctMISC,                  ssctLINKDOT,                       ssctMISC,                  ssctCOMPASSLT,                     ssctMISC,                  ssctCOMPASSDK,                     1,                            1,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoMINIMAPTITLE,                     pos,                     48,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS3,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoCOUNTERS,                         pos,                     88,          16,          32,           32,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       1,                      sstsSHADOWED,                4,                      '~',                    0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoSSTIME,                           pos,                    240,           0,           0,            0,            ssctMISC,                  ssctTEXT,                          0,                         0,                                 ssctSYSTEM,                -1,                                ssfZELDA,                     sstaRIGHT,              sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    132,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { sso2X2FRAME,                         pos,                    156,          16,           3,            4,            ssctMISC,                  sscsBLUEFRAMECSET,                 0,                         0,                                 0,                         0,                                 0,                            0,                      1,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                    136,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBUTTONITEM,                       pos,                    160,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    144,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWEDU,               0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "B" },
            { ssoTEXT,                             pos,                    168,          16,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsOUTLINED8,               0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "A" },
            { ssoLINE,                             pos,                    163,          15,         174,            1,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             pos,                    216,          16,           0,            0,            ssctMISC,                  ssctCAPTION,                       ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaCENTER,             sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "-  life  -" },
            { ssoLIFEMETER,                        pos,                    184,          24,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            1,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoNONE,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoBSTIME,                           sspUP,                  208,          48,           0,            0,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctSUBSCRSHADOW,                  ssctSYSTEM,                -1,                                ssfSS1,                       sstaLEFT,               sstsSHADOWED,                0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoRECT,                             sspUP,                  160,          48,          44,            7,            ssctMISC,                  ssctTEXT,                          ssctMISC,                  ssctTEXT,                          0,                         0,                                 1,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspUP,                  204,          48,           1,            8,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoLINE,                             sspUP,                  160,          55,          45,            1,            ssctMISC,                  ssctSUBSCRSHADOW,                  0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
            { ssoTEXT,                             sspUP,                  161,          49,           0,            0,            ssctMISC,                  ssctSUBSCRBG,                      0,                         0,                                 ssctSYSTEM,                -1,                                ssfZTIME,                     sstaLEFT,               sstsNORMAL,                  0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0, (void *) "ZELDA TIME" },
            { ssoNULL,                             pos,                      0,           0,           0,            0,            0,                         0,                                 0,                         0,                                 0,                         0,                                 0,                            0,                      0,                           0,                      0,                      0,                      0,                      0,                      0,                      0,                      0,             0,            0,            0,             NULL },
        }
    }
};

void textout_styled_aligned_ex(BITMAP *bmp, const FONT *f, const char *s, int x, int y, int textstyle, int alignment, int color, int shadow, int bg)
{
    switch(alignment)
    {
    case sstaRIGHT:
        switch(textstyle)
        {
        case sstsSHADOW:
            textout_shadow_right_ex(bmp, f, s, x, y, shadow, bg);
            break;
            
        case sstsSHADOWU:
            textout_shadow_right_u_ex(bmp, f, s, x, y, shadow, bg);
            break;
            
        case sstsOUTLINE8:
            textout_shadow_right_o_ex(bmp, f, s, x, y, shadow, bg);
            break;
            
        case sstsOUTLINEPLUS:
            textout_shadow_right_plus_ex(bmp, f, s, x, y, shadow, bg);
            break;
            
        case sstsOUTLINEX:
            textout_shadow_right_x_ex(bmp, f, s, x, y, shadow, bg);
            break;
            
        case sstsSHADOWED:
            textout_shadowed_right_ex(bmp, f, s, x, y, color, shadow, bg);
            break;
            
        case sstsSHADOWEDU:
            textout_shadowed_right_u_ex(bmp, f, s, x, y, color, shadow, bg);
            break;
            
        case sstsOUTLINED8:
            textout_shadowed_right_o_ex(bmp, f, s, x, y, color, shadow, bg);
            break;
            
        case sstsOUTLINEDPLUS:
            textout_shadowed_right_plus_ex(bmp, f, s, x, y, color, shadow, bg);
            break;
            
        case sstsOUTLINEDX:
            textout_shadowed_right_x_ex(bmp, f, s, x, y, color, shadow, bg);
            break;
            
        case sstsNORMAL:
        default:
            textout_right_ex(bmp, f, s, x, y, color, bg);
            break;
        }
        
        break;
        
    case sstaCENTER:
        switch(textstyle)
        {
        case sstsSHADOW:
            textout_shadow_centre_ex(bmp, f, s, x, y, shadow, bg);
            break;
            
        case sstsSHADOWU:
            textout_shadow_centre_u_ex(bmp, f, s, x, y, shadow, bg);
            break;
            
        case sstsOUTLINE8:
            textout_shadow_centre_o_ex(bmp, f, s, x, y, shadow, bg);
            break;
            
        case sstsOUTLINEPLUS:
            textout_shadow_centre_plus_ex(bmp, f, s, x, y, shadow, bg);
            break;
            
        case sstsOUTLINEX:
            textout_shadow_centre_x_ex(bmp, f, s, x, y, shadow, bg);
            break;
            
        case sstsSHADOWED:
            textout_shadowed_centre_ex(bmp, f, s, x, y, color, shadow, bg);
            break;
            
        case sstsSHADOWEDU:
            textout_shadowed_centre_u_ex(bmp, f, s, x, y, color, shadow, bg);
            break;
            
        case sstsOUTLINED8:
            textout_shadowed_centre_o_ex(bmp, f, s, x, y, color, shadow, bg);
            break;
            
        case sstsOUTLINEDPLUS:
            textout_shadowed_centre_plus_ex(bmp, f, s, x, y, color, shadow, bg);
            break;
            
        case sstsOUTLINEDX:
            textout_shadowed_centre_x_ex(bmp, f, s, x, y, color, shadow, bg);
            break;
            
        case sstsNORMAL:
        default:
            textout_centre_ex(bmp, f, s, x, y, color, bg);
            break;
        }
        
        break;
        
    case sstaLEFT:
    default:
        switch(textstyle)
        {
        case sstsSHADOW:
            textout_shadow_ex(bmp, f, s, x, y, shadow, bg);
            break;
            
        case sstsSHADOWU:
            textout_shadow_u_ex(bmp, f, s, x, y, shadow, bg);
            break;
            
        case sstsOUTLINE8:
            textout_shadow_o_ex(bmp, f, s, x, y, shadow, bg);
            break;
            
        case sstsOUTLINEPLUS:
            textout_shadow_plus_ex(bmp, f, s, x, y, shadow, bg);
            break;
            
        case sstsOUTLINEX:
            textout_shadow_x_ex(bmp, f, s, x, y, shadow, bg);
            break;
            
        case sstsSHADOWED:
            textout_shadowed_ex(bmp, f, s, x, y, color, shadow, bg);
            break;
            
        case sstsSHADOWEDU:
            textout_shadowed_u_ex(bmp, f, s, x, y, color, shadow, bg);
            break;
            
        case sstsOUTLINED8:
            textout_shadowed_o_ex(bmp, f, s, x, y, color, shadow, bg);
            break;
            
        case sstsOUTLINEDPLUS:
            textout_shadowed_plus_ex(bmp, f, s, x, y, color, shadow, bg);
            break;
            
        case sstsOUTLINEDX:
            textout_shadowed_x_ex(bmp, f, s, x, y, color, shadow, bg);
            break;
            
        case sstsNORMAL:
        default:
            textout_ex(bmp, f, s, x, y, color, bg);
            break;
        }
        
        break;
    }
}

void textprintf_styled_aligned_ex(BITMAP *bmp, const FONT *f, int x, int y, int textstyle, int alignment, int color, int shadow, int bg, const char *format, ...)
{

    char buf[512];
    va_list ap;
    ASSERT(bmp);
    ASSERT(f);
    ASSERT(format);
    
    va_start(ap, format);
    uvszprintf(buf, sizeof(buf), format, ap);
    va_end(ap);
    
    textout_styled_aligned_ex(bmp, f, buf, x, y, textstyle, alignment, color, shadow, bg);
}


void draw_textbox(BITMAP *dest, int x, int y, int w, int h, FONT *tempfont, char *thetext, bool wword, int tabsize, int alignment, int textstyle, int color, int shadowcolor, int backcolor)
{
    int y1 = y;
    int x1;
    int len;
    char s[16];
    char text[16];
    char space[16];
    char *printed = text;
    char *scanned = text;
    char *oldscan = text;
    char *ignore = NULL;
    char *tmp, *ptmp;
    int width;
    int i = 0;
    int noignore;
    
    usetc(s+usetc(s, '.'), 0);
    usetc(text+usetc(text, ' '), 0);
    usetc(space+usetc(space, ' '), 0);
    
    /* find the correct text */
    if(thetext != NULL)
    {
        printed = thetext;
        scanned = thetext;
    }
    
    /* loop over the entire string */
    for(;;)
    {
        width = 0;
        
        /* find the next break */
        while(ugetc(scanned))
        {
            /* check for a forced break */
            if(ugetc(scanned) == '\n')
            {
                scanned += uwidth(scanned);
                /* we are done parsing the line end */
                break;
            }
            
            /* the next character length */
            usetc(s+usetc(s, ugetc(scanned)), 0);
            len = text_length(tempfont, s);
            
            /* modify length if its a tab */
            if(ugetc(s) == '\t')
            {
                len = tabsize * text_length(tempfont, space);
            }
            
            /* check for the end of a line by excess width of next char */
            if(width+len >= w)
            {
                /* we have reached end of line do we go back to find start */
                if(wword)
                {
                    /* remember where we were */
                    oldscan = scanned;
                    noignore = FALSE;
                    
                    /* go backwards looking for start of word */
                    while(!uisspace(ugetc(scanned)))
                    {
                        /* don't wrap too far */
                        if(scanned == printed)
                        {
                            /* the whole line is filled, so stop here */
                            tmp = ptmp = scanned;
                            
                            while(ptmp != oldscan)
                            {
                                ptmp = tmp;
                                tmp += uwidth(tmp);
                            }
                            
                            scanned = ptmp;
                            noignore = TRUE;
                            break;
                        }
                        
                        /* look further backwards to wrap */
                        tmp = ptmp = printed;
                        
                        while(tmp < scanned)
                        {
                            ptmp = tmp;
                            tmp += uwidth(tmp);
                        }
                        
                        scanned = ptmp;
                    }
                    
                    /* put the space at the end of the line */
                    if(!noignore)
                    {
                        ignore = scanned;
                        scanned += uwidth(scanned);
                    }
                    else
                    {
                        ignore = NULL;
                    }
                    
                    /* check for endline at the convenient place */
                    if(ugetc(scanned) == '\n')
                    {
                        scanned += uwidth(scanned);
                    }
                }
                
                /* we are done parsing the line end */
                break;
            }
            
            /* the character can be added */
            scanned += uwidth(scanned);
            width += len;
        }
        
        /* check if we are to print it */
        if((y1+text_height(tempfont) <= (y+h)))
        {
            int tempw=0;
            char *tempprinted=printed;
            
            /* print up to the marked character */
            while(printed != scanned)
            {
                /* do special stuff for each charater */
                switch(ugetc(printed))
                {
                case '\r':
                case '\n':
                    /* don't print endlines in the text */
                    break;
                    
                    /* possibly expand the tabs */
                case '\t':
                    for(i=0; i<tabsize; i++)
                    {
                        usetc(s+usetc(s, ' '), 0);
                        tempw += text_length(tempfont, s);
                    }
                    
                    break;
                    
                    /* print a normal character */
                default:
                    if(printed != ignore)
                    {
                        usetc(s+usetc(s, ugetc(printed)), 0);
                        tempw += text_length(tempfont, s);
                    }
                }
                
                /* goto the next character */
                printed += uwidth(printed);
            }
            
            printed=tempprinted;
            
            switch(alignment)
            {
            case sstaRIGHT:
                x1=x+w-tempw;
                break;
                
            case sstaCENTER:
                x1=x+((w-tempw)/2)+1;
                break;
                
            case sstaLEFT:
            default:
                x1 = x;
                break;
            }
            
            /* print up to the marked character */
            while(printed != scanned)
            {
                /* do special stuff for each charater */
                switch(ugetc(printed))
                {
                
                case '\r':
                case '\n':
                    /* don't print endlines in the text */
                    break;
                    
                    /* possibly expand the tabs */
                case '\t':
                    for(i=0; i<tabsize; i++)
                    {
                        usetc(s+usetc(s, ' '), 0);
                        textout_styled_aligned_ex(dest, tempfont, s, x1, y1, textstyle, sstaLEFT, color, shadowcolor, backcolor);
                        x1 += text_length(tempfont, s);
                    }
                    
                    break;
                    
                    /* print a normal character */
                default:
                    if(printed != ignore)
                    {
                        usetc(s+usetc(s, ugetc(printed)), 0);
                        textout_styled_aligned_ex(dest, tempfont, s, x1, y1, textstyle, sstaLEFT, color, shadowcolor, backcolor);
                        x1 += text_length(tempfont, s);
                    }
                }
                
                /* goto the next character */
                printed += uwidth(printed);
            }
            
            /* print the line end */
            y1 += text_height(tempfont);
        }
        else
        {
            scanned += uwidth(scanned);
        }
        
        printed = scanned;
        
        /* check if we are at the end of the string */
        if(!ugetc(printed))
        {
            return;
        }
    }
}



//void frame2x2(BITMAP *dest,miscQdata *misc,int x,int y,int xsize,int ysize,int t,int c)
//draw_block_flip(dest,x,y,css->objects[i].d1,subscreen_cset(misc, css->objects[i].colortype1, css->objects[i].color1),css->objects[i].w,css->objects[i].h,css->objects[i].d2,css->objects[i].d3,css->objects[i].d4);
void frame2x2(BITMAP *dest,miscQdata *misc,int x,int y,int tile,int cset,int w,int h,int /*flip*/,bool overlay,bool trans)
{
    /*
      /- -- -- -\
      |         |
      |         |
      \_ __ __ _/
    
      0  1  4  5
      2  3  6  7
      80 81 84 85
      82 83 86 87
      */
    if(tile==0)
    {
        tile=misc->colors.blueframe_tile;
    }
    
    int t8 = tile<<2;
    
    if(overlay)
    {
        if(trans)
        {
            for(int dx=0; dx<w; dx++)
            {
                int top    = (dx >= (w>>1)) ? ((dx==w-1) ? t8+5  : t8+4) : ((dx==0) ? t8    : t8+1);
                int bottom = (dx >= (w>>1)) ? ((dx==w-1) ? t8+87 : t8+86) : ((dx==0) ? t8+82 : t8+83);
                
                overtiletranslucent8(dest,top,(dx<<3)+x,y,cset,0,128);
                overtiletranslucent8(dest,bottom,(dx<<3)+x,((h-1)<<3)+y,cset,0,128);
            }
            
            for(int dy=1; dy<h-1; dy++)
            {
                int left  = (dy >= (h>>1)) ? t8+80 : t8+2;
                int right = (dy >= (h>>1)) ? t8+85 : t8+7;
                
                overtiletranslucent8(dest,left,x,(dy<<3)+y,cset,0,128);
                overtiletranslucent8(dest,right,((w-1)<<3)+x,(dy<<3)+y,cset,0,128);
                
                for(int dx=1; dx<w-1; dx++)
                {
                    int fill = (dy >= (h>>1)) ? ((dx >= (w>>1)) ? t8+84 : t8+81) : ((dx >= (w>>1)) ? t8+6 : t8+3);
                    overtiletranslucent8(dest,fill,(dx<<3)+x,(dy<<3)+y,cset,0,128);
                }
            }
        }
        else
        {
            for(int dx=0; dx<w; dx++)
            {
                int top    = (dx >= (w>>1)) ? ((dx==w-1) ? t8+5  : t8+4) : ((dx==0) ? t8    : t8+1);
                int bottom = (dx >= (w>>1)) ? ((dx==w-1) ? t8+87 : t8+86) : ((dx==0) ? t8+82 : t8+83);
                
                overtile8(dest,top,(dx<<3)+x,y,cset,0);
                overtile8(dest,bottom,(dx<<3)+x,((h-1)<<3)+y,cset,0);
            }
            
            for(int dy=1; dy<h-1; dy++)
            {
                int left  = (dy >= (h>>1)) ? t8+80 : t8+2;
                int right = (dy >= (h>>1)) ? t8+85 : t8+7;
                
                overtile8(dest,left,x,(dy<<3)+y,cset,0);
                overtile8(dest,right,((w-1)<<3)+x,(dy<<3)+y,cset,0);
                
                for(int dx=1; dx<w-1; dx++)
                {
                    int fill = (dy >= (h>>1)) ? ((dx >= (w>>1)) ? t8+84 : t8+81) : ((dx >= (w>>1)) ? t8+6 : t8+3);
                    overtile8(dest,fill,(dx<<3)+x,(dy<<3)+y,cset,0);
                }
            }
        }
    }
    else
    {
        if(trans)
        {
            for(int dx=0; dx<w; dx++)
            {
                int top    = (dx >= (w>>1)) ? ((dx==w-1) ? t8+5  : t8+4) : ((dx==0) ? t8    : t8+1);
                int bottom = (dx >= (w>>1)) ? ((dx==w-1) ? t8+87 : t8+86) : ((dx==0) ? t8+82 : t8+83);
                
                puttiletranslucent8(dest,top,(dx<<3)+x,y,cset,0,128);
                puttiletranslucent8(dest,bottom,(dx<<3)+x,((h-1)<<3)+y,cset,0,128);
            }
            
            for(int dy=1; dy<h-1; dy++)
            {
                int left  = (dy >= (h>>1)) ? t8+80 : t8+2;
                int right = (dy >= (h>>1)) ? t8+85 : t8+7;
                
                puttiletranslucent8(dest,left,x,(dy<<3)+y,cset,0,128);
                puttiletranslucent8(dest,right,((w-1)<<3)+x,(dy<<3)+y,cset,0,128);
                
                for(int dx=1; dx<w-1; dx++)
                {
                    int fill = (dy >= (h>>1)) ? ((dx >= (w>>1)) ? t8+84 : t8+81) : ((dx >= (w>>1)) ? t8+6 : t8+3);
                    puttiletranslucent8(dest,fill,(dx<<3)+x,(dy<<3)+y,cset,0,128);
                }
            }
        }
        else
        {
            for(int dx=0; dx<w; dx++)
            {
                int top    = (dx >= (w>>1)) ? ((dx==w-1) ? t8+5  : t8+4) : ((dx==0) ? t8    : t8+1);
                int bottom = (dx >= (w>>1)) ? ((dx==w-1) ? t8+87 : t8+86) : ((dx==0) ? t8+82 : t8+83);
                
                oldputtile8(dest,top,(dx<<3)+x,y,cset,0);
                oldputtile8(dest,bottom,(dx<<3)+x,((h-1)<<3)+y,cset,0);
            }
            
            for(int dy=1; dy<h-1; dy++)
            {
                int left  = (dy >= (h>>1)) ? t8+80 : t8+2;
                int right = (dy >= (h>>1)) ? t8+85 : t8+7;
                
                oldputtile8(dest,left,x,(dy<<3)+y,cset,0);
                oldputtile8(dest,right,((w-1)<<3)+x,(dy<<3)+y,cset,0);
                
                for(int dx=1; dx<w-1; dx++)
                {
                    int fill = (dy >= (h>>1)) ? ((dx >= (w>>1)) ? t8+84 : t8+81) : ((dx >= (w>>1)) ? t8+6 : t8+3);
                    oldputtile8(dest,fill,(dx<<3)+x,(dy<<3)+y,cset,0);
                }
            }
        }
    }
}

void drawgrid(BITMAP *dest,int x,int y,int c1,int c2)
{
    int si=0;
    
    for(int y2=0; y2<=7; ++y2)
    {
        byte dl = DMaps[get_currdmap()].grid[si];
        
        for(int x2=0; x2<=7; ++x2)
        {
            if(c2==-1)
            {
                if(dl&0x80)
                    rectfill(dest,(x2*8)+x,(y2*4)+y,(x2*8)+x+6,(y2*4)+y+2,c1);
            }
            else
            {
                rectfill(dest,(x2*8)+x,(y2*4)+y,(x2*8)+x+6,(y2*4)+y+2,c2);
                
                if(dl&0x80)
                    rectfill(dest,(x2*8)+x+2,(y2*4)+y,(x2*8)+x+4,(y2*4)+y+2,c1);
            }
            
            dl<<=1;
        }
        
        ++si;
    }
}

void draw_block(BITMAP *dest,int x,int y,int tile,int cset,int w,int h)
{
    for(int j=0; j<h; j++)
        for(int i=0; i<w; i++)
            overtile16(dest,tile+j*20+i,x+(i<<4),y+(j<<4),cset,0);
}

void draw_block_flip(BITMAP *dest,int x,int y,int tile,int cset,int w,int h,int flip,bool overlay,bool trans)
{
    if(overlay)
    {
        switch(flip&3)
        {
        case 0:
            if(trans)
            {
                for(int j=0; j<h; j++)
                {
                    for(int i=0; i<w; i++)
                    {
                        overtiletranslucent16(dest,tile+j*20+i,x+(i<<4),y+(j<<4),cset,0,255-trans);
                    }
                }
            }
            else
            {
                for(int j=0; j<h; j++)
                {
                    for(int i=0; i<w; i++)
                    {
                        overtile16(dest,tile+j*20+i,x+(i<<4),y+(j<<4),cset,0);
                    }
                }
            }
            
            break;
            
        case 1: //horizontal
            if(trans)
            {
                for(int j=0; j<h; j++)
                {
                    for(int i=0; i<w; i++)
                    {
                        overtiletranslucent16(dest,tile+j*20+(w-i-1),x+(i<<4),y+(j<<4),cset,1,255-trans);
                    }
                }
            }
            else
            {
                for(int j=0; j<h; j++)
                {
                    for(int i=0; i<w; i++)
                    {
                        overtile16(dest,tile+j*20+(w-i-1),x+(i<<4),y+(j<<4),cset,1);
                    }
                }
            }
            
            break;
            
        case 2:
            if(trans)
            {
                for(int j=0; j<h; j++)
                {
                    for(int i=0; i<w; i++)
                    {
                        overtiletranslucent16(dest,tile+(h-j-1)*20+i,x+(i<<4),y+(j<<4),cset,2,255-trans);
                    }
                }
            }
            else
            {
                for(int j=0; j<h; j++)
                {
                    for(int i=0; i<w; i++)
                    {
                        overtile16(dest,tile+(h-j-1)*20+i,x+(i<<4),y+(j<<4),cset,2);
                    }
                }
            }
            
            break;
            
        case 3:
            if(trans)
            {
                for(int j=0; j<h; j++)
                {
                    for(int i=0; i<w; i++)
                    {
                        overtiletranslucent16(dest,tile+(h-j-1)*20+(w-i-1),x+(i<<4),y+(j<<4),cset,3,255-trans);
                    }
                }
            }
            else
            {
                for(int j=0; j<h; j++)
                {
                    for(int i=0; i<w; i++)
                    {
                        overtile16(dest,tile+(h-j-1)*20+(w-i-1),x+(i<<4),y+(j<<4),cset,3);
                    }
                }
            }
            
            break;
        }
    }
    else
    {
        switch(flip&3)
        {
        case 0:
            if(trans)
            {
                for(int j=0; j<h; j++)
                {
                    for(int i=0; i<w; i++)
                    {
                        puttiletranslucent16(dest,tile+j*20+i,x+(i<<4),y+(j<<4),cset,0,255-trans);
                    }
                }
            }
            else
            {
                for(int j=0; j<h; j++)
                {
                    for(int i=0; i<w; i++)
                    {
                        oldputtile16(dest,tile+j*20+i,x+(i<<4),y+(j<<4),cset,0);
                    }
                }
            }
            
            break;
            
        case 1: //horizontal
            if(trans)
            {
                for(int j=0; j<h; j++)
                {
                    for(int i=0; i<w; i++)
                    {
                        puttiletranslucent16(dest,tile+j*20+(w-i-1),x+(i<<4),y+(j<<4),cset,1,255-trans);
                    }
                }
            }
            else
            {
                for(int j=0; j<h; j++)
                {
                    for(int i=0; i<w; i++)
                    {
                        oldputtile16(dest,tile+j*20+(w-i-1),x+(i<<4),y+(j<<4),cset,1);
                    }
                }
            }
            
            break;
            
        case 2:
            if(trans)
            {
                for(int j=0; j<h; j++)
                {
                    for(int i=0; i<w; i++)
                    {
                        puttiletranslucent16(dest,tile+(h-j-1)*20+i,x+(i<<4),y+(j<<4),cset,2,255-trans);
                    }
                }
            }
            else
            {
                for(int j=0; j<h; j++)
                {
                    for(int i=0; i<w; i++)
                    {
                        oldputtile16(dest,tile+(h-j-1)*20+i,x+(i<<4),y+(j<<4),cset,2);
                    }
                }
            }
            
            break;
            
        case 3:
            if(trans)
            {
                for(int j=0; j<h; j++)
                {
                    for(int i=0; i<w; i++)
                    {
                        puttiletranslucent16(dest,tile+(h-j-1)*20+(w-i-1),x+(i<<4),y+(j<<4),cset,3,255-trans);
                    }
                }
            }
            else
            {
                for(int j=0; j<h; j++)
                {
                    for(int i=0; i<w; i++)
                    {
                        oldputtile16(dest,tile+(h-j-1)*20+(w-i-1),x+(i<<4),y+(j<<4),cset,3);
                    }
                }
            }
            
            break;
        }
    }
}

void drawdmap(BITMAP *dest, miscQdata *misc, int x, int y, bool showmap, int showlink, int showcompass, int linkcolor, int lccolor, int dccolor)
{
    zcolors c=misc->colors;
    int type = (DMaps[get_currdmap()].type&dmfTYPE);
    
    if(showmap)
    {
        switch(type)
        {
        case dmOVERW:
        case dmBSOVERW:
        
            if(DMaps[get_currdmap()].minimap_1_tile)
            {
                draw_block(dest,x,y,DMaps[get_currdmap()].minimap_1_tile,DMaps[get_currdmap()].minimap_1_cset,5,3);
            }
            else if(c.overworld_map_tile)
            {
                draw_block(dest,x,y,c.overworld_map_tile,c.overworld_map_cset,5,3);
            }
            else
            {
                rectfill(dest,x+8,y+8,x+71,y+39,c.overw_bg);
            }
            
            if(!DMaps[get_currdmap()].minimap_1_tile && ((DMaps[get_currdmap()].type&dmfTYPE) == dmBSOVERW))
            {
                drawgrid(dest,x+8,y+8,c.bs_goal,c.bs_dk);
            }
            
            break;
            
        case dmDNGN:
        case dmCAVE:
            int maptile=has_item(itype_map, get_dlevel())?DMaps[get_currdmap()].minimap_2_tile:DMaps[get_currdmap()].minimap_1_tile;
            int mapcset=has_item(itype_map, get_dlevel())?DMaps[get_currdmap()].minimap_2_cset:DMaps[get_currdmap()].minimap_1_cset;
            
            if(maptile)
            {
                draw_block(dest,x,y,maptile,mapcset,5,3);
            }
            else if(c.dungeon_map_tile)
            {
                draw_block(dest,x,y,c.dungeon_map_tile,c.dungeon_map_cset,5,3);
            }
            else
            {
                rectfill(dest,x+8,y+8,x+71,y+39,c.dngn_bg);
            }
            
            if(!DMaps[get_currdmap()].minimap_2_tile && has_item(itype_map, get_dlevel()))
            {
                if((DMaps[get_currdmap()].flags&dmfMINIMAPCOLORFIX) != 0)
                {
                    drawgrid(dest,x+8,y+8,c.cave_fg,-1);
                }
                else
                {
                    drawgrid(dest,x+8,y+8,c.dngn_fg,-1);
                }
            }
            
            break;
        }
    }
    
    if(showcompass)
    {
        if(type==dmDNGN || type==dmCAVE)
        {
            if(show_subscreen_dmap_dots&&has_item(itype_compass, get_dlevel()))
            {
                int c2 = dccolor;
                
                if(!has_item(itype_triforcepiece, get_dlevel()) && (frame&16))
                    c2 = lccolor;
                    
                int cx = ((DMaps[get_currdmap()].compass&15)<<3)+x+10;
                int cy = ((DMaps[get_currdmap()].compass&0xF0)>>2)+y+8;
                putdot(dest,cx,cy,c2);
            }
        }
    }
    
    if(showlink)
    {
        if(show_subscreen_dmap_dots && linkcolor != 255)
        {
            if(type==dmOVERW)
            {
                putdot(dest,((get_homescr()&15)<<2)+x+9,((get_homescr()&0xF0)>>2)+y+8,linkcolor);
            }
            else if(type==dmBSOVERW || ((type==dmDNGN || type==dmCAVE) && get_currscr()<128))
            {
                putdot(dest,(((get_homescr()&15)-DMaps[get_currdmap()].xoff)<<3)+x+10,((get_homescr()&0xF0)>>2)+y+8,linkcolor);
            }
        }
    }
}



void lifemeter(BITMAP *dest,int x,int y,int tile,bool bs_style)
{
    if(!show_subscreen_life)
    {
        return;
    }
    
    if(!bs_style)
    {
        y+=24;
    }
    
    for(int i=0; i<(game != NULL ? zc_min(game->get_maxlife(),16*24) : 1); i+=HP_PER_HEART)
    {
        if(game != NULL)
        {
            if(get_bit(quest_rules,qr_QUARTERHEART))
            {
                if(i+((HP_PER_HEART/4)*3)>=game->get_life()) tile=(wpnsbuf[iwQuarterHearts].tile*4)+2;
                
                if(i+(HP_PER_HEART/2)>=game->get_life()) tile=1;
                
                if(i+((HP_PER_HEART/4)*1)>=game->get_life()) tile=(wpnsbuf[iwQuarterHearts].tile*4)+3;
            }
            else if(i+(HP_PER_HEART/2)>=game->get_life()) tile=1;
            
            if(i>=game->get_life()) tile=4;
        }
        else
            tile=4;
            
        overtile8(dest,tile,x,y,1,0);
        x+=8;
        
        if(((i>>4)&7)==7)
        {
            x-=64;
            y+=bs_style?8:-8;
        }
    }
}

void magicgauge(BITMAP *dest,int x,int y, int container, int notlast_tile, int notlast_cset, bool notlast_mod, int last_tile, int last_cset, bool last_mod,
                int cap_tile, int cap_cset, bool cap_mod, int aftercap_tile, int aftercap_cset, bool aftercap_mod, int frames, int speed, int delay, bool unique_last, int show)
{
    //these are here to bypass compiler warnings about unused arguments
    frames=frames;
    speed=speed;
    delay=delay;
    
    // show
    //   0: always
    //   1: 1/2 magic
    //   2: normal magic
    if(show!=0)
    {
        if(show==1 && game->get_magicdrainrate()!=1)
            return;
        if(show==2 && game->get_magicdrainrate()!=2)
            return;
    }
    
    int containers=game->get_maxmagic()/MAGICPERBLOCK;
    int tile=rand()%32767, cset=rand()%15;
    bool mod_value=(rand()%2)!=0;
    
    if(container<containers)
    {
        tile=notlast_tile;
        cset=notlast_cset;
        mod_value=notlast_mod;
    }
    else if(container==containers)
    {
        tile=last_tile;
        cset=last_cset;
        mod_value=last_mod;
    }
    else if(container==containers+1)
    {
        tile=cap_tile;
        cset=cap_cset;
        mod_value=cap_mod;
    }
    else //if (container>containers+1)
    {
        tile=aftercap_tile;
        cset=aftercap_cset;
        mod_value=aftercap_mod;
    }
    
    if(mod_value)
    {
        if(game->get_magic()>=container*MAGICPERBLOCK)
        {
            //tile=tile;                                        //full block
            if(game->get_magic()==container*MAGICPERBLOCK)
            {
                if(unique_last)
                {
                    tile+=35;
                }
            }
        }
        else
        {
            if(((container-1)*MAGICPERBLOCK)>game->get_magic())
            {
                tile+=4;                                //empty block
            }
            else
            {
                tile+=4+((game->get_magic()-((container-1)*MAGICPERBLOCK))%MAGICPERBLOCK);
            }
        }
    }
    
    //tile=14161*4;
    overtile8(dest,tile,x,y,cset,0);
    
}

void lifegauge(BITMAP *dest,int x,int y, int container, int notlast_tile, int notlast_cset, bool notlast_mod, int last_tile, int last_cset, bool last_mod,
               int cap_tile, int cap_cset, bool cap_mod, int aftercap_tile, int aftercap_cset, bool aftercap_mod, int frames, int speed, int delay, bool unique_last)
{
    //these are here to bypass compiler warnings about unused arguments
    frames=frames;
    speed=speed;
    delay=delay;
    
    int containers=game->get_maxlife()/HP_PER_HEART;
    int tile=rand()%32767, cset=rand()%15;
    bool mod_value=(rand()%2)!=0;
    
    if(container<containers)
    {
        tile=notlast_tile;
        cset=notlast_cset;
        mod_value=notlast_mod;
    }
    else if(container==containers)
    {
        tile=last_tile;
        cset=last_cset;
        mod_value=last_mod;
    }
    else if(container==containers+1)
    {
        tile=cap_tile;
        cset=cap_cset;
        mod_value=cap_mod;
    }
    else //if (container>containers+1)
    {
        tile=aftercap_tile;
        cset=aftercap_cset;
        mod_value=aftercap_mod;
    }
    
    if(mod_value)
    {
        if(game->get_life()>=container*HP_PER_HEART)
        {
            //tile=tile;                                        //full block
            if(game->get_life()==container*HP_PER_HEART)
            {
                if(unique_last)
                {
                    tile+=19;
                }
            }
        }
        else
        {
            if(((container-1)*HP_PER_HEART)>game->get_life())
            {
                tile+=4;                                //empty block
            }
            else
            {
                tile+=4+((game->get_life()-((container-1)*HP_PER_HEART))%HP_PER_HEART);
            }
        }
    }
    
    overtile8(dest,tile,x,y,cset,0);
    
}


void magicmeter(BITMAP *dest,int x,int y)
{
    if(!get_bit(quest_rules,qr_ENABLEMAGIC)) return;
    
    if(game->get_maxmagic()==0) return;
    
    int tile;
    int mmtile=wpnsbuf[iwMMeter].tile;
    int mmcset=wpnsbuf[iwMMeter].csets&15;
    overtile8(dest,(mmtile*4)+2,x-8,y,mmcset,0);
    
    if(game->get_magicdrainrate()==1)
    {
        overtile8(dest,(mmtile*4)+1,x-10,y,mmcset,0);
    }
    
    for(int i=0; i<game->get_maxmagic(); i+=MAGICPERBLOCK)
    {
        if(game->get_magic()>=i+MAGICPERBLOCK)
        {
            tile=mmtile*4;                                        //full block
        }
        else
        {
            if(i>game->get_magic())
            {
                tile=((mmtile+1)*4);                                //empty block
            }
            else
            {
                tile=((mmtile+1)*4)+((game->get_magic()-i)%MAGICPERBLOCK);
            }
        }
        
        overtile8(dest,tile,x,y,mmcset,0);
        x+=8;
    }
    
    overtile8(dest,(mmtile*4)+3,x,y,mmcset,0);
    
}

void putxnum(BITMAP *dest,int x,int y,int num,FONT *tempfont,int color,int shadowcolor,int bgcolor,int textstyle,bool usex,int digits,bool infinite,char idigit)
{
    if(!show_subscreen_numbers)
    {
        return;
    }
    
    int found_digits=5;
    
    if(num<10000)
    {
        found_digits=4;
    }
    
    if(num<1000)
    {
        found_digits=3;
    }
    
    if(num<100)
    {
        found_digits=2;
    }
    
    if(num<10)
    {
        found_digits=1;
    }
    
    if(infinite)
    {
        textprintf_styled_aligned_ex(dest,tempfont,x,y,textstyle,sstaLEFT,color,shadowcolor,bgcolor,"%s%c",usex?"X":"",idigit);
    }
    else
    {
        textprintf_styled_aligned_ex(dest,tempfont,x,y,textstyle,sstaLEFT,color,shadowcolor,bgcolor,"%s%d",(usex && found_digits<digits)?"X":"",num);
    }
}

/*
  INLINE void putdot(BITMAP *dest,int x,int y,int c)
  {
  rectfill(dest,x,y,x+2,y+2,c);
  }
  */

/****  Subscr items code  ****/

item *Bitem = NULL, *Aitem = NULL;
int   Bid = 0, Aid = 0;

void reset_subscr_items()
{
    if(Aitem)
    {
        delete Aitem;
        Aitem = NULL;
    }
    
    if(Bitem)
    {
        delete Bitem;
        Bitem = NULL;
    }
    
    Aid = Bid = 0;
}


void update_subscr_items()
{
    if(Bid != Bwpn)
    {
        Bid = 0;
        
        if(Bitem)
        {
            delete Bitem;
            Bitem = NULL;
        }
        
        if(Bwpn > 0)
        {
            Bitem = new item((fix)0, (fix)0, (fix)0, Bwpn&0x0FFF, 0, 0);
            Bitem->dummy_bool[0]=false;
            
            switch(itemsbuf[Bwpn&0x0FFF].family)
            {
            case itype_arrow:
                if((Bwpn&0xF000)==0xF000)
                {
                    Bitem->dummy_bool[0]=true;
                }
                
                break;
            }
            
            //      Bitem = new item((fix)(zinit.subscreen<ssdtBSZELDA?124:136), (fix)24,(fix)0, Bwpn, 0, 0);
            if(Bitem != NULL)
            {
                Bid = Bwpn;
                Bitem->yofs = 0;
                Bitem->pickup |= ipDUMMY;
            }
        }
    }
    
    if(Aid != Awpn)
    {
        Aid = 0;
        
        if(Aitem)
        {
            delete Aitem;
            Aitem = NULL;
        }
        
        if(Awpn > 0)
        {
            Aitem = new item((fix)0, (fix)0,(fix)0,Awpn&0x0FFF, 0, 0);
            
            switch(itemsbuf[Awpn&0x0FFF].family)
            {
            case itype_arrow:
                if((Awpn&0xF000)==0xF000)
                {
                    Aitem->dummy_bool[0]=true;
                }
                
                break;
            }
            
            if(Aitem != NULL)
            {
                Aid = Awpn;
                Aitem->yofs = 0;
                Aitem->pickup |= ipDUMMY;
            }
        }
    }
    
    if(Bitem)
        Bitem->animate(0);
        
    if(Aitem)
        Aitem->animate(0);
}

void add_subscr_item(item *newItem)
{
    newItem->subscreenItem=true;
    Sitems.add(newItem);
}

/****/
int stripspaces(char *source, char *target, int stop)
{
    int begin, end;
    
    for(begin=0; ((begin<stop)&&(source[begin]==' ')); ++begin)
    {
        /* do nothing */
    }
    
    if(begin==stop)
    {
        return 0;
    }
    
    for(end=stop-1; ((source[end]==' ')); --end)
    {
        /* do nothing */
    }
    
    sprintf(target, "%.*s", (end-begin+1), source+begin);
    return (end-begin+1);
}

// The conditions on which a subcreen item should be displayed.
bool displaysubscreenitem(int itemtype, int d)
{
    if(game==NULL)  //ZQuest
        return true;
        
    if((itemtype == itype_bomb &&
            !(game->get_bombs()
              // Remote Bombs: the bomb icon can still be used when an undetonated bomb is onscreen.
              || (itemsbuf[current_item_id(itype_bomb)].misc1==0 && Lwpns.idCount(wLitBomb)>0)
              || current_item_power(itype_bombbag)))
            || (itemtype == itype_sbomb &&
                !(game->get_sbombs()
                  || (itemsbuf[current_item_id(itype_sbomb)].misc1==0 && Lwpns.idCount(wLitSBomb)>0)
                  || (current_item_power(itype_bombbag)
                      && itemsbuf[current_item_id(itype_bombbag)].flags & ITEM_FLAG1))))
        return false;
        
    if(itemtype!=itype_bowandarrow ||
            d!=itype_arrow ||
            ((get_bit(quest_rules,qr_TRUEARROWS)&&game->get_arrows()) ||
             (!get_bit(quest_rules,qr_TRUEARROWS)&&game->get_rupies())))
        return true;
        
    return false;
}

void subscreenitem(BITMAP *dest, int x, int y, int itemtype)
{
    // We need to do a reverse loop to prevent the Bow from being drawn above the Arrow (Bow & Arrow).
    int overridecheck = 0xFFFF;
    
    for(int i=Sitems.Count()-1; i>=0; i--)
    {
        if(itemtype & 0x8000) // if 0x8000, then itemtype is actually an item ID.
        {
            if(overridecheck==0xFFFF)
                if(Sitems.spr(i)->id == (itemtype&0xFFF) && Sitems.spr(i)->misc==-1) overridecheck = i;
        }
        else if(Sitems.spr(i)->misc!=-1)
        {
            int d= itemsbuf[Sitems.spr(i)->id].family;
            
            if((d==itemtype)||
                    (itemtype==itype_letterpotion&&((d==itype_letter && current_item_id(itype_potion)==-1)||d==itype_potion))||
                    (itemtype==itype_bowandarrow&&(d==itype_bow||d==itype_arrow)))
            {
                Sitems.spr(i)->x = x;
                Sitems.spr(i)->y = y;
                Sitems.spr(i)->yofs=0;
                
                if(displaysubscreenitem(itemtype, d))
                {
                    Sitems.spr(i)->draw(dest);
                }
                
                if(itemtype!=itype_bowandarrow)
                {
                    return;
                }
            }
        }
    }
    
    //Item Override stuff here
    if((itemtype & 0x8000) && (has_item(itemsbuf[itemtype&0xFFF].family,itemsbuf[itemtype&0xFFF].fam_type))
            && !item_disabled(itemtype&0xFFF) && displaysubscreenitem(itemsbuf[itemtype&0xFFF].family, 0))
    {
        if(overridecheck == 0xFFFF)
        {
            add_subscr_item(new item((fix)x,(fix)y,(fix)0,(itemtype&0xFFF),0,0));
            overridecheck = Sitems.Count()-1;
            Sitems.spr(overridecheck)->misc = -1;
        }
        
        Sitems.spr(overridecheck)->x = x;
        Sitems.spr(overridecheck)->y = y;
        Sitems.spr(overridecheck)->yofs=0;
        Sitems.spr(overridecheck)->draw(dest);
    }
}

int subscreen_color(miscQdata *misc, int c1, int c2)
{
    int ret;
    
    switch(c1)
    {
    case ssctSYSTEM:
        ret=(c2==-1)?c2:vc(c2);
        break;
        
    case ssctMISC:
        switch(c2)
        {
        case ssctTEXT:
            ret=misc->colors.text;
            break;
            
        case ssctCAPTION:
            ret=misc->colors.caption;
            break;
            
        case ssctOVERWBG:
            ret=misc->colors.overw_bg;
            break;
            
        case ssctDNGNBG:
            ret=misc->colors.dngn_bg;
            break;
            
        case ssctDNGNFG:
            ret=misc->colors.dngn_fg;
            break;
            
        case ssctCAVEFG:
            ret=misc->colors.cave_fg;
            break;
            
        case ssctBSDK:
            ret=misc->colors.bs_dk;
            break;
            
        case ssctBSGOAL:
            ret=misc->colors.bs_goal;
            break;
            
        case ssctCOMPASSLT:
            ret=misc->colors.compass_lt;
            break;
            
        case ssctCOMPASSDK:
            ret=misc->colors.compass_dk;
            break;
            
        case ssctSUBSCRBG:
            ret=misc->colors.subscr_bg;
            break;
            
        case ssctSUBSCRSHADOW:
            ret=misc->colors.subscr_shadow;
            break;
            
        case ssctTRIFRAMECOLOR:
            ret=misc->colors.triframe_color;
            break;
            
        case ssctBMAPBG:
            ret=misc->colors.bmap_bg;
            break;
            
        case ssctBMAPFG:
            ret=misc->colors.bmap_fg;
            break;
            
        case ssctLINKDOT:
            ret=misc->colors.link_dot;
            break;
            
        default:
            ret=(rand()*1000)%256;
            break;
        }
        
        break;
        
    default:
        ret=(c1<<4)+c2;
    }
    
    return ret;
}



int subscreen_cset(miscQdata *misc,int c1, int c2)
{
    int ret=c1;
    
    switch(c1)
    {
    case ssctMISC:
        switch(c2)
        {
        case sscsTRIFORCECSET:
            ret=misc->colors.triforce_cset;
            break;
            
        case sscsTRIFRAMECSET:
            ret=misc->colors.triframe_cset;
            break;
            
        case sscsOVERWORLDMAPCSET:
            ret=misc->colors.overworld_map_cset;
            break;
            
        case sscsDUNGEONMAPCSET:
            ret=misc->colors.dungeon_map_cset;
            break;
            
        case sscsBLUEFRAMECSET:
            ret=misc->colors.blueframe_cset;
            break;
            
        case sscsHCPIECESCSET:
            ret=misc->colors.HCpieces_cset;
            break;
            
        case sscsSSVINECSET:
            ret=wpnsbuf[iwSubscreenVine].csets&15;
            break;
            
        default:
            ret=(rand()*1000)%256;
            break;
        }
        
        break;
        
    default:
        ret=c1;
    }
    
    return ret;
}

FONT *ss_font(int fontnum)
{
    FONT *tempfont;
    
    switch(fontnum)
    {
    case ssfSMALL:
        tempfont=sfont;
        break;
        
    case ssfSMALLPROP:
        tempfont=spfont;
        break;
        
    case ssfSS1:
        tempfont=ssfont1;
        break;
        
    case ssfSS2:
        tempfont=ssfont2;
        break;
        
    case ssfSS3:
        tempfont=ssfont3;
        break;
        
    case ssfSS4:
        tempfont=ssfont4;
        break;
        
    case ssfZTIME:
        tempfont=ztfont;
        break;
        
    case ssfZELDA:
        tempfont=zfont;
        break;
        
    case ssfZ3:
        tempfont=z3font;
        break;
        
    case ssfZ3SMALL:
        tempfont=z3smallfont;
        break;
        
    case ssfGBLA:
        tempfont=gblafont;
        break;
        
    case ssfGORON:
        tempfont=goronfont;
        break;
        
    case ssfZORAN:
        tempfont=zoranfont;
        break;
        
    case ssfHYLIAN1:
        tempfont=hylian1font;
        break;
        
    case ssfHYLIAN2:
        tempfont=hylian2font;
        break;
        
    case ssfHYLIAN3:
        tempfont=hylian3font;
        break;
        
    case ssfHYLIAN4:
        tempfont=hylian4font;
        break;
        
    case ssfPROP:
        tempfont=font;
        break;
        
    case ssfGBORACLE:
        tempfont=gboraclefont;
        break;
        
    case ssfGBORACLEP:
        tempfont=gboraclepfont;
        break;
        
    case ssfDSPHANTOM:
        tempfont=dsphantomfont;
        break;
        
    case ssfDSPHANTOMP:
        tempfont=dsphantompfont;
        break;
        
    default:
        fontnum=rand()%ssfMAX;
        tempfont=ss_font(fontnum);
        break;
    }
    
    return tempfont;
}

item *sel_a=NULL, *sel_b=NULL;


void delete_selectors()
{
    if(sel_a)
    {
        delete sel_a;
        sel_a=NULL;
    }
    
    if(sel_b)
    {
        delete sel_b;
        sel_b=NULL;
    }
}


void animate_selectors()
{
    if(new_sel)
    {
        delete_selectors();
        new_sel = false;
    }
    
    if(!sel_a)
        sel_a = new item((fix)0, (fix)0, (fix)0, iSelectA, 0, 0);
        
    if(!sel_b)
        sel_b = new item((fix)0, (fix)0, (fix)0, iSelectB, 0, 0);
        
    sel_a->yofs=0;
    sel_a->animate(0);
    sel_b->yofs=0;
    sel_b->animate(0);
}

void show_custom_subscreen(BITMAP *dest, miscQdata *misc, subscreen_group *css, int xofs, int yofs, bool showtime, int pos2)
{
    //this is not a good place to be clearing the bitmap
    //other stuff might already have been drawn on it that needs to be kept
    //(eg the game screen when pulling down the subscreen) -DD
    //clear_to_color(dest, 0);
    color_map=&trans_table;
    set_trans_blender(0, 0, 0, 128);
    
    //doing animation here leads to 2x speed when drawing both active and passive subscreen -DD
    /*static item sel_a((fix)0,(fix)0,(fix)0,iSelectA,0,0);
    static item sel_b((fix)0,(fix)0,(fix)0,iSelectB,0,0);
    if (new_sel)
    {
      sel_a=item((fix)0,(fix)0,(fix)0,iSelectA,0,0);
      sel_b=item((fix)0,(fix)0,(fix)0,iSelectB,0,0);
      new_sel=false;
    }
    sel_a.yofs=0;
    sel_a.animate(0);
    sel_b.yofs=0;
    sel_b.animate(0);*/
    if(!sel_a || !sel_b)
        animate_selectors();
        
    for(int i=0; i<MAXSUBSCREENITEMS&&css->objects[i].type>ssoNULL; ++i)
    {
        if((css->objects[i].pos & pos2) != 0)
        {
            FONT *tempfont=zfont;
            int fontnum=css->objects[i].d1;
            tempfont=ss_font(fontnum);
            int x=css->objects[i].x+xofs;
            int y=css->objects[i].y+yofs;
            
            switch(css->objects[i].type)
            {
            case sso2X2FRAME:
            {
                frame2x2(dest, misc, x, y, css->objects[i].d1, subscreen_cset(misc, css->objects[i].colortype1, css->objects[i].color1), css->objects[i].w, css->objects[i].h, css->objects[i].d2, css->objects[i].d3 != 0, css->objects[i].d4 != 0);
            }
            break;
            
            case ssoBSTIME:
            {
                char *ts;
                
                if(game)
                    ts = time_str_short2(game->get_time());
                else
                    ts = time_str_short2(0);
                    
//          textout_shadowed_ex(dest,tempfont,ts,x,y,subscreen_color(misc, css->objects[i].colortype1, css->objects[i].color1),subscreen_color(misc, css->objects[i].colortype2, css->objects[i].color2),subscreen_color(misc, css->objects[i].colortype3, css->objects[i].color3));
                textout_styled_aligned_ex(dest,tempfont,ts,x,y,css->objects[i].d3,css->objects[i].d2,subscreen_color(misc, css->objects[i].colortype1, css->objects[i].color1),subscreen_color(misc, css->objects[i].colortype2, css->objects[i].color2),subscreen_color(misc, css->objects[i].colortype3, css->objects[i].color3));
            }
            break;
            
            case ssoSSTIME:
            case ssoTIME:
            {
                if(showtime||css->objects[i].type==ssoTIME)
                {
                    char *ts;
                    
                    if(game)
                        ts = time_str_med(game->get_time());
                    else
                        ts = time_str_med(0);
                        
//            textout_right_ex(dest,tempfont,ts,x,y,subscreen_color(misc, css->objects[i].colortype1, css->objects[i].color1),subscreen_color(misc, css->objects[i].colortype2, css->objects[i].color2));
                    textout_styled_aligned_ex(dest,tempfont,ts,x,y,css->objects[i].d3,css->objects[i].d2,subscreen_color(misc, css->objects[i].colortype1, css->objects[i].color1),subscreen_color(misc, css->objects[i].colortype2, css->objects[i].color2),subscreen_color(misc, css->objects[i].colortype3, css->objects[i].color3));
                }
            }
            break;
            
            case ssoTEXT:
            {
                //textout_styled_aligned_ex(bmp, f,       s,                          x,y,textstyle,         alignment,         color,                                                                    shadow,                                                                   bg)
                textout_styled_aligned_ex(dest,tempfont,(char *)css->objects[i].dp1,x,y,css->objects[i].d3,css->objects[i].d2,subscreen_color(misc, css->objects[i].colortype1, css->objects[i].color1),subscreen_color(misc, css->objects[i].colortype2, css->objects[i].color2),subscreen_color(misc, css->objects[i].colortype3, css->objects[i].color3));
            }
            break;
            
            case ssoLINE:
            {
                if(css->objects[i].d4)
                {
                    drawing_mode(DRAW_MODE_TRANS, NULL, 0, 0);
                }
                
                line(dest, x, y, x+css->objects[i].w-1, y+css->objects[i].h-1, subscreen_color(misc, css->objects[i].colortype1, css->objects[i].color1));
                
                if(css->objects[i].d4)
                {
                    drawing_mode(DRAW_MODE_SOLID, NULL, 0, 0);
                }
            }
            break;
            
            case ssoRECT:
            {
                if(css->objects[i].d2)
                {
                    drawing_mode(DRAW_MODE_TRANS, NULL, 0, 0);
                }
                
                if(css->objects[i].d1!=0)
                {
                    rectfill(dest, x, y, x+css->objects[i].w-1, y+css->objects[i].h-1, subscreen_color(misc, css->objects[i].colortype2, css->objects[i].color2));
                }
                
                rect(dest, x, y, x+css->objects[i].w-1, y+css->objects[i].h-1, subscreen_color(misc, css->objects[i].colortype1, css->objects[i].color1));
                
                if(css->objects[i].d2)
                {
                    drawing_mode(DRAW_MODE_SOLID, NULL, 0, 0);
                }
            }
            break;
            
            case ssoMAGICMETER:
            {
                magicmeter(dest, x, y);
            }
            break;
            
            case ssoLIFEMETER:
            {
                lifemeter(dest, x, y, css->objects[i].d1, css->objects[i].d2 != 0);
            }
            break;
            
            case ssoBUTTONITEM:
            {
                if(css->objects[i].d2)
                {
                    drawing_mode(DRAW_MODE_TRANS, NULL, 0, 0);
                }
                
                buttonitem(dest, css->objects[i].d1, x, y);
                
                if(css->objects[i].d2)
                {
                    drawing_mode(DRAW_MODE_SOLID, NULL, 0, 0);
                }
            }
            break;
            
            case ssoCOUNTERS:
            {
                defaultcounters(dest, x, y, tempfont,subscreen_color(misc, css->objects[i].colortype1, css->objects[i].color1),subscreen_color(misc, css->objects[i].colortype2, css->objects[i].color2),subscreen_color(misc, css->objects[i].colortype3, css->objects[i].color3),css->objects[i].d2 != 0,css->objects[i].d3,css->objects[i].d4,css->objects[i].d5);
            }
            break;
            
            case ssoCOUNTER:
            {
                counter(dest, x, y, tempfont,subscreen_color(misc, css->objects[i].colortype1, css->objects[i].color1),subscreen_color(misc, css->objects[i].colortype2, css->objects[i].color2),subscreen_color(misc, css->objects[i].colortype3, css->objects[i].color3),css->objects[i].d2,css->objects[i].d3,css->objects[i].d4,css->objects[i].d5,css->objects[i].d6&1, css->objects[i].d7, css->objects[i].d8, css->objects[i].d9, css->objects[i].d10, (css->objects[i].d6&2)!=0);
            }
            break;
            
            case ssoMINIMAPTITLE:
            {
                if(!css->objects[i].d4 || has_item(itype_map, get_dlevel()))
                {
                    minimaptitle(dest, x, y, tempfont, subscreen_color(misc, css->objects[i].colortype1, css->objects[i].color1),subscreen_color(misc, css->objects[i].colortype2, css->objects[i].color2),subscreen_color(misc, css->objects[i].colortype3, css->objects[i].color3), css->objects[i].d2, css->objects[i].d3);
                }
            }
            break;
            
            case ssoMINIMAP:
            {
                //drawdmap(dest, misc, x, y, showmap,                 showlink,           showcompass,        linkcolor,                                                                 lccolor,                                                                   dccolor)
                drawdmap(dest, misc, x, y, css->objects[i].d1 != 0, css->objects[i].d2 && !(TheMaps[(DMaps[get_currdmap()].map*MAPSCRS)+get_homescr()].flags7&fNOLINKMARK),
                         css->objects[i].d3 && !(DMaps[get_currdmap()].flags&dmfNOCOMPASS), subscreen_color(misc, css->objects[i].colortype1, css->objects[i].color1), subscreen_color(misc, css->objects[i].colortype2, css->objects[i].color2), subscreen_color(misc, css->objects[i].colortype3, css->objects[i].color3));
            }
            break;
            
            case ssoLARGEMAP:
            {
                //putBmap(dest, misc, x, y, showmap,                 showlink,              showrooms,             roomcolor,                                                                 linkcolor,                                                                 large)
                putBmap(dest, misc, x, y, css->objects[i].d1 != 0, css->objects[i].d2!=0, css->objects[i].d3!=0, subscreen_color(misc, css->objects[i].colortype1, css->objects[i].color1), subscreen_color(misc, css->objects[i].colortype2, css->objects[i].color2), css->objects[i].d10 != 0);
            }
            break;
            
            case ssoCLEAR:
            {
                clear_to_color(dest,subscreen_color(misc, css->objects[i].colortype1, css->objects[i].color1));
            }
            break;
            
            case ssoCURRENTITEM:
            {
                // Shouldn't really be checking is_zquest here, but it's okay for now...
                if(css->objects[i].d2 || (is_zquest() && (zinit.ss_flags&ssflagSHOWINVIS)!=0))
                {
                    subscreenitem(dest, x, y, css->objects[i].d8>0 ? ((css->objects[i].d8-1) | 0x8000) : css->objects[i].d1);
                }
            }
            break;
            
            case ssoTEXTBOX:
            {
                //draw_textbox(dest, x, y, w,                 h,                 tempfont, thetext,                     wword,                 tabsize,            alignment,          textstyle,          color,                                                                     shadowcolor,                                                               backcolor)
                draw_textbox(dest, x, y, css->objects[i].w, css->objects[i].h, tempfont, (char *)css->objects[i].dp1, css->objects[i].d4!=0, css->objects[i].d5, css->objects[i].d2, css->objects[i].d3, subscreen_color(misc, css->objects[i].colortype1, css->objects[i].color1), subscreen_color(misc, css->objects[i].colortype2, css->objects[i].color2), subscreen_color(misc, css->objects[i].colortype3, css->objects[i].color3));
//          draw_textbox(dest, 0, 0, 200, 50, sfont, "This is a test", 1, 4, 0, 0, subscreen_color(misc, css->objects[i].colortype1, css->objects[i].color1), subscreen_color(misc, css->objects[i].colortype2, css->objects[i].color2), subscreen_color(misc, css->objects[i].colortype3, css->objects[i].color3));
            }
            break;
            
            case ssoSELECTEDITEMNAME:
            {
                int itemid=Bweapon(Bpos);
                
                // If it's a combined bow and arrow, the item ID will have 0xF000 added.
                if(itemid>=0xF000)
                    itemid-=0xF000;
                
                // 0 can mean either the item with index 0 is selected or there's no
                // valid item to select, so be sure Link has whatever it would be.
                if(!game->get_item(itemid))
                    break;
                    
                char itemname[140]="";
                sprintf(itemname, "%s", item_string[itemid]);
                
                switch(itemsbuf[itemid].family)
                {
                case itype_arrow:
                    if(Bitem->dummy_bool[0]==true)  //if we also have a bow
                    {
                        if(current_item_id(itype_bow))
                        {
                            bool hasarrows=((get_bit(quest_rules,qr_TRUEARROWS)&&(game==NULL || game->get_arrows()))||(!get_bit(quest_rules,qr_TRUEARROWS)&&(game==NULL || game->get_rupies())));
                            sprintf(itemname, "%s%s%s", item_string[current_item_id(itype_bow)], hasarrows?" & ":"",hasarrows?item_string[Bitem->id]:"");
                            /*switch (current_item_power(itype_bow))
                            {
                              case 1:
                              sprintf(itemname, "Short Bow%s%s", hasarrows?" & ":"",hasarrows?item_string[Bitem->id]:"");
                              break;
                              case 2:
                              sprintf(itemname, "Long Bow%s%s", hasarrows?" & ":"",hasarrows?item_string[Bitem->id]:"");
                              break;
                            }*/
                        }
                    }
                    
                    break;
                }
                
                draw_textbox(dest, x, y, css->objects[i].w, css->objects[i].h, tempfont, itemname, css->objects[i].d4!=0, css->objects[i].d5, css->objects[i].d2, css->objects[i].d3, subscreen_color(misc, css->objects[i].colortype1, css->objects[i].color1), subscreen_color(misc, css->objects[i].colortype2, css->objects[i].color2), subscreen_color(misc, css->objects[i].colortype3, css->objects[i].color3));
                // draw_textbox(dest, x, y, w,                 h,                 tempfont, thetext,  wword,                 tabsize,            alignment,          textstyle,          color,                                             shadowcolor,                                       backcolor);
            }
            break;
            
            case ssoTRIFRAME:
            {
//        puttriframe(dest, misc, x, y, triframecolor,                                                             numbercolor,                                                               triframetile,       triframecset,       triforcetile,       triforcecset,       showframe,             showpieces,            largepieces)
                puttriframe(dest, misc, x, y, subscreen_color(misc, css->objects[i].colortype1, css->objects[i].color1), subscreen_color(misc, css->objects[i].colortype2, css->objects[i].color2), css->objects[i].d1, css->objects[i].d2, css->objects[i].d3, css->objects[i].d4, css->objects[i].d5!=0, css->objects[i].d6!=0, css->objects[i].d7!=0);
            }
            break;
            
            case ssoTRIFORCE:
            {
                puttriforce(dest,misc,x,y,css->objects[i].d1,subscreen_cset(misc, css->objects[i].colortype1, css->objects[i].color1),css->objects[i].w,css->objects[i].h,css->objects[i].d2,css->objects[i].d3!=0,css->objects[i].d4!=0,css->objects[i].d5);
            }
            break;
            
            case ssoTILEBLOCK:
            {
                draw_block_flip(dest,x,y,css->objects[i].d1,subscreen_cset(misc, css->objects[i].colortype1, css->objects[i].color1),css->objects[i].w,css->objects[i].h,css->objects[i].d2,css->objects[i].d3!=0,css->objects[i].d4!=0);
            }
            break;
            
            case ssoMINITILE:
            {
                int t=css->objects[i].d1;
                
                if(t==-1)
                {
                    switch(css->objects[i].d2)
                    {
                    case ssmstSSVINETILE:
                        t=wpnsbuf[iwSubscreenVine].tile*4;
                        break;
                        
                    case ssmstMAGICMETER:
                        t=wpnsbuf[iwMMeter].tile*4;
                        break;
                        
                    default:
                        t=(rand()*100000)%32767;
                        break;
                    }
                }
                
                t+=css->objects[i].d3;
                
                if(css->objects[i].d5)
                {
                    if(css->objects[i].d6)
                    {
                        overtiletranslucent8(dest,t,x,y,subscreen_cset(misc, css->objects[i].colortype1, css->objects[i].color1),css->objects[i].d4,128);
                    }
                    else
                    {
                        overtile8(dest,t,x,y,subscreen_cset(misc, css->objects[i].colortype1, css->objects[i].color1),css->objects[i].d4);
                    }
                }
                else
                {
                    if(css->objects[i].d6)
                    {
                        puttiletranslucent8(dest,t,x,y,subscreen_cset(misc, css->objects[i].colortype1, css->objects[i].color1),css->objects[i].d4,128);
                    }
                    else
                    {
                        oldputtile8(dest,t,x,y,subscreen_cset(misc, css->objects[i].colortype1, css->objects[i].color1),css->objects[i].d4);
                    }
                }
            }
            break;
            
            case ssoSELECTOR1:
            case ssoSELECTOR2:
            {
                int p=-1;
                
                for(int j=0; j<MAXSUBSCREENITEMS&&css->objects[j].type!=ssoNULL; ++j)
                {
                    if(css->objects[j].type==ssoCURRENTITEM)
                    {
                        if(css->objects[j].d3==(int)Bpos)
                        {
                            p=j;
                            break;
                        }
                    }
                }
                
                bool big_sel=css->objects[i].d5 != 0;
                item *tempsel=(css->objects[i].type==ssoSELECTOR1)?sel_a:sel_b;
                int temptile=tempsel->tile;
                tempsel->drawstyle=0;
                
                if(css->objects[i].d4)
                {
                    tempsel->drawstyle=1;
                }
                
                for(int j=0; j<4; ++j)
                {
                    if(p!=-1)
                    {
                        tempsel->x=css->objects[p].x+xofs+(big_sel?(j%2?8:-8):0);
                        tempsel->y=css->objects[p].y+yofs+(big_sel?(j>1?8:-8):0);
                        tempsel->tile+=(zc_max(itemsbuf[tempsel->id].frames,1)*j);
                        
                        if(temptile)
                        {
                            tempsel->draw(dest);
                            tempsel->tile=temptile;
                        }
                        
                        if(!big_sel)
                        {
                            break;
                        }
                    }
                }
                
            }
            break;
            
            case ssoMAGICGAUGE:
            {
                //          void magicgauge(BITMAP *dest,int x,int y, int container, int notlast_tile, int notlast_cset, bool notlast_mod, int last_tile, int last_cset, bool last_mod,
                //                          int cap_tile, int cap_cset, bool cap_mod, int aftercap_tile, int aftercap_cset, bool aftercap_mod, int frames, int speed, int delay, bool unique_last,
                //                          int show)
                magicgauge(dest,x,y, css->objects[i].d1, css->objects[i].d2, css->objects[i].colortype1, ((css->objects[i].d10&1)?1:0), css->objects[i].d3, css->objects[i].color1, ((css->objects[i].d10&2)?1:0),
                           css->objects[i].d4, css->objects[i].colortype2, ((css->objects[i].d10&4)?1:0), css->objects[i].d5, css->objects[i].color2, ((css->objects[i].d10&8)?1:0), css->objects[i].d6, css->objects[i].d7, css->objects[i].d8, ((css->objects[i].d10&16)?1:0),
                           css->objects[i].d9);
            }
            break;
            
            case ssoLIFEGAUGE:
            {
                lifegauge(dest,x,y, css->objects[i].d1, css->objects[i].d2, css->objects[i].colortype1, ((css->objects[i].d10&1)?1:0), css->objects[i].d3, css->objects[i].color1, ((css->objects[i].d10&2)?1:0),
                          css->objects[i].d4, css->objects[i].colortype2, ((css->objects[i].d10&4)?1:0), css->objects[i].d5, css->objects[i].color2, ((css->objects[i].d10&8)?1:0), css->objects[i].d6, css->objects[i].d7, css->objects[i].d8, ((css->objects[i].d10&16)?1:0));
            }
            break;
            
            default:
            {
            }
            break;
            }
            
            //sso_bounding_box(dest, css, i, vc(15));
        }
    }
}


void buttonitem(BITMAP *dest, int button, int x, int y)
{
    switch(button)
    {
    case 0:  //A button
        if(Aitem&&show_subscreen_items)
        {
            Aitem->x=x;
            Aitem->y=y;
            
            switch(itemsbuf[Aitem->id].family)
            {
            case itype_arrow:
                if(Aitem->dummy_bool[0]==true)
                {
                    if(current_item_id(itype_bow)>-1)
                    {
                        subscreenitem(dest, x, y, itype_bow);
                        
                        if(((get_bit(quest_rules,qr_TRUEARROWS)&&!game->get_arrows())
                                ||(!get_bit(quest_rules,qr_TRUEARROWS)&&!game->get_rupies()&&!current_item_power(itype_wallet)))
                                &&!current_item_power(itype_quiver))
                        {
                            return;
                        }
                    }
                }
                
                break;
            }
            
            Aitem->draw(dest);
        }
        
        break;
        
    case 1:  //B button
        if(Bitem&&show_subscreen_items)
        {
            Bitem->x=x;
            Bitem->y=y;
            
            switch(itemsbuf[Bitem->id].family)
            {
            case itype_arrow:
                if(Bitem->dummy_bool[0]==true)
                {
                    if(current_item_id(itype_bow)>-1)
                    {
                        subscreenitem(dest, x, y, itype_bow);
                        
                        if(((get_bit(quest_rules,qr_TRUEARROWS)&&(game != NULL && !game->get_arrows()))
                                ||(!get_bit(quest_rules,qr_TRUEARROWS)&&(game != NULL && !game->get_rupies())&&!current_item_power(itype_wallet)))
                                &&!current_item_power(itype_quiver))
                        {
                            return;
                        }
                    }
                }
                
                break;
            }
            
            Bitem->draw(dest);
        }
        
        break;
        
    default:
        break;
    }
}

void defaultcounters(BITMAP *dest, int x, int y, FONT *tempfont, int color, int shadowcolor, int bgcolor, bool usex, int textstyle, int digits, char idigit)
{
    int yofs = (game==NULL || (game->get_sbombs() && current_item_id(itype_sbomb)>-1)) ? 8 : 0;
    
    //88, 16
    overtile8(dest,5,x,y,1,0);
    overtile8(dest,8,x,y+16-yofs,1,0);
    overtile8(dest,9,x,y+24-yofs,0,0);
    
    if(game)
    {
        bool magickey = false;
        int itemid = current_item_id(itype_magickey);
        
        if(itemid>-1)
        {
            if(itemsbuf[itemid].flags&ITEM_FLAG1)
                magickey = itemsbuf[itemid].power>=get_dlevel();
            else
                magickey = itemsbuf[itemid].power==get_dlevel();
        }
        
        putxnum(dest,x+8,y,game->get_rupies(),tempfont,color,shadowcolor,bgcolor,textstyle,usex,digits,current_item_power(itype_wallet)>0,idigit);
        putxnum(dest,x+8,y+16-yofs,game->get_keys()+game->get_lkeys(),tempfont,color,shadowcolor,bgcolor, textstyle,usex,digits,magickey,idigit);
        putxnum(dest,x+8,y+24-yofs,game->get_bombs(),tempfont,color,shadowcolor,bgcolor,textstyle,usex,digits,current_item_power(itype_bombbag)>0,idigit);
    }
    
    if(game==NULL || (game->get_sbombs() && current_item_id(itype_sbomb)>-1))
    {
        overtile8(dest,13,x,y+24,1,0);
        
        if(game)
        {
            int itemid = current_item_id(itype_bombbag);
            bool superbomb = (itemid>=0 && itemsbuf[itemid].power>0 && itemsbuf[itemid].flags & ITEM_FLAG1);
            
            putxnum(dest,x+8,y+24,game->get_sbombs(),tempfont,color,shadowcolor,bgcolor,textstyle,usex,digits,superbomb,idigit);
        }
    }
}

bool is_counter_item(int itemtype, int countertype)
{
    switch(countertype)
    {
    case sscBOMBS:
        if(itemsbuf[itemtype].family==itype_bomb)
        {
            return true;
        }
        
        break;
        
    case sscSBOMBS:
        if(itemsbuf[itemtype].family==itype_sbomb)
        {
            return true;
        }
        
        break;
        
    case sscARROWS:
        if(itemsbuf[itemtype].family==itype_arrow)
        {
            return true;
        }
        
        break;
    }
    
    return false;
}

void counter(BITMAP *dest, int x, int y, FONT *tempfont, int color, int shadowcolor, int bgcolor, int alignment, int textstyle, int digits, char idigit, bool showzero, int itemtype1, int itemtype2, int itemtype3, int infiniteitem, bool onlyselected)
{
    int value=0;
    bool infinite=false;
    
    if(game != NULL && game->get_item(infiniteitem) && !item_disabled(infiniteitem))
    {
        infinite=true;
    }
    
    char valstring[80];
    char formatstring[80];
    sprintf(valstring,"01234567890123456789");
    sprintf(formatstring, "%%0%dd", digits);
    
    if(onlyselected && !(((Bitem&&(is_counter_item(Bitem->id,itemtype1)||is_counter_item(Bitem->id,itemtype2)||is_counter_item(Bitem->id,itemtype3)))||(Aitem&&(is_counter_item(Aitem->id,itemtype1)||is_counter_item(Aitem->id,itemtype2)||is_counter_item(Aitem->id,itemtype3))))))
    {
        return;
    }
    
    int itemtype;
    /*
    for (int i=0; i<3; ++i)
    {
      switch (i)
      {
        case 0:
          itemtype=itemtype1;
          break;
        case 1:
          itemtype=itemtype2;
          break;
        case 2:
          itemtype=itemtype3;
          break;
      }
    */
    itemtype=itemtype1;
    /* commented out until I find out what it does - it's messing up custom subscreens now as
    itemtype2 and 3 are zero - so link's life gets added to the counters */
    
    switch(itemtype)
    {
    case sscRUPEES:
        if(current_item_power(itype_wallet))
            infinite=true;
            
        value+=game->get_rupies();
        break;
        
    case sscBOMBS:
        if(current_item_power(itype_bombbag))
            infinite=true;
            
        value+=game->get_bombs();
        break;
        
    case sscSBOMBS:
    {
        int itemid = current_item_id(itype_bombbag);
        
        if(itemid>-1 && itemsbuf[itemid].power>0 && itemsbuf[itemid].flags & ITEM_FLAG1)
            infinite=true;
            
        value+=game->get_sbombs();
        break;
    }
    
    case sscARROWS:
        if((!get_bit(quest_rules,qr_TRUEARROWS) && current_item_power(itype_wallet)) || current_item_power(itype_quiver))
            infinite=true;
            
        // If Link somehow got ammunition before getting the arrow,
        // or if the arrow was disabled in a DMap,
        // we shouldn't put the value as zero.
//        if(/*current_item_id(itype_arrow)>-1*/ true)
        {
            if(get_bit(quest_rules,qr_TRUEARROWS))
            {
                value+=game->get_arrows();
            }
            else
            {
                value+=game->get_rupies();
            }
        }
        break;
        
    case sscGENKEYMAGIC:
    case sscLEVKEYMAGIC:
    case sscANYKEYMAGIC:
    {
        int itemid = current_item_id(itype_magickey);
        
        if(itemid>-1 && !infinite)
        {
            if(itemsbuf[itemid].flags&ITEM_FLAG1)
                infinite = itemsbuf[itemid].power>=get_dlevel();
            else
                infinite = itemsbuf[itemid].power==get_dlevel();
        }
    }
    
    //fall through
    case sscANYKEYNOMAGIC:
    case sscLEVKEYNOMAGIC:
    case sscGENKEYNOMAGIC:
        if(itemtype == sscGENKEYNOMAGIC || itemtype == sscANYKEYNOMAGIC
                || itemtype == sscGENKEYMAGIC || itemtype == sscANYKEYMAGIC)
            value += game->get_keys();
            
        if(itemtype == sscLEVKEYNOMAGIC || itemtype == sscANYKEYNOMAGIC
                || itemtype == sscLEVKEYMAGIC || itemtype == sscANYKEYMAGIC)
            value += game->get_lkeys();
            
        break;
        
    case sscSCRIPT1:
    case sscSCRIPT2:
    case sscSCRIPT3:
    case sscSCRIPT4:
    case sscSCRIPT5:
    case sscSCRIPT6:
    case sscSCRIPT7:
    case sscSCRIPT8:
    case sscSCRIPT9:
    case sscSCRIPT10:
    case sscSCRIPT11:
    case sscSCRIPT12:
    case sscSCRIPT13:
    case sscSCRIPT14:
    case sscSCRIPT15:
    case sscSCRIPT16:
    case sscSCRIPT17:
    case sscSCRIPT18:
    case sscSCRIPT19:
    case sscSCRIPT20:
    case sscSCRIPT21:
    case sscSCRIPT22:
    case sscSCRIPT23:
    case sscSCRIPT24:
    case sscSCRIPT25:
        value += game->get_counter(itemtype-3);
        
    default:
        break;
    }
    
    // (for loop) }
    if(!showzero&&!value&&!infinite)
    {
        return;
    }
    
    if(infinite)
    {
        sprintf(valstring, "%c", idigit);
    }
    else
    {
        sprintf(valstring, formatstring, value);
    }
    
    textout_styled_aligned_ex(dest,tempfont,valstring,x,y,textstyle,alignment,color,shadowcolor,bgcolor);
    
    //  putxnum(dest,x+8,y,game->get_rupies(),tempfont,color,shadowcolor,bgcolor,shadowed,usex,digits,0,idigit);
}

void minimaptitle(BITMAP *dest, int x, int y, FONT *tempfont, int color, int shadowcolor, int bgcolor, int alignment, int textstyle)
{
    char dmaptitlesource[2][11];
    char dmaptitle[2][11];
    sprintf(dmaptitlesource[0], "%.10s", DMaps[get_currdmap()].title);
    sprintf(dmaptitlesource[1], "%.10s", DMaps[get_currdmap()].title+10);
    
    int title_len1=stripspaces(dmaptitlesource[0], dmaptitle[0], 10);
    int title_len2=stripspaces(dmaptitlesource[1], dmaptitle[1], 10);
    
    if((title_len1>0)||(title_len2>0))
    {
        if((title_len1>0)&&(title_len2>0))
        {
            textprintf_styled_aligned_ex(dest,tempfont,x,y+8,textstyle,alignment,color,shadowcolor,bgcolor,"%s",dmaptitle[1]);
            textprintf_styled_aligned_ex(dest,tempfont,x,y,textstyle,alignment,color,shadowcolor,bgcolor,"%s",dmaptitle[0]);
        }
        else
        {
            if(title_len1>0)
            {
                textprintf_styled_aligned_ex(dest,tempfont,x,y+8,textstyle,alignment,color,shadowcolor,bgcolor,"%s",dmaptitle[0]);
            }
            else
            {
                textprintf_styled_aligned_ex(dest,tempfont,x,y+8,textstyle,alignment,color,shadowcolor,bgcolor,"%s",dmaptitle[1]);
            }
        }
    }
}

void put_passive_subscr(BITMAP *dest,miscQdata *misc,int x,int y,bool showtime,int pos2)
{
    // uncomment this?
    //  load_Sitems();
    Sitems.animate();
    update_subscr_items();
    BITMAP *subscr = create_sub_bitmap(dest,x,y,256,passive_subscreen_height);
    
    if(no_subscreen())
    {
        clear_to_color(subscr,0);
        destroy_bitmap(subscr);
        return;
    }
    
    show_custom_subscreen(subscr, misc, current_subscreen_passive, 0, 0, showtime, pos2);
    destroy_bitmap(subscr);
}

/*
  const byte tripiece[8*3] =
  {
  112,112,0, 128,112,1, 96,128,0, 144,128,1,
  112,128,2, 112,128,1, 128,128,3, 128,128,0
  };
  */

void puttriframe(BITMAP *dest, miscQdata *misc, int x, int y, int triframecolor, int numbercolor, int triframetile, int triframecset, int triforcetile, int triforcecset, bool showframe, bool showpieces, bool largepieces)
{
    if(triframetile==0)
    {
        triframetile=misc->colors.triframe_tile;
        triframecset=misc->colors.triframe_cset;
    }
    
    if(triforcetile==0)
    {
        triforcetile=misc->colors.triforce_tile;
        triforcecset=misc->colors.triforce_cset;
    }
    
    if(!largepieces)
    {
        if(showframe)
        {
            if(triframetile)
            {
                draw_block(dest,x,y,triframetile,triframecset,6,3);
            }
            else
            {
                line(dest,x+47,y,x+1,y+46,triframecolor);
                line(dest,x+48,y,x+94,y+46,triframecolor);
                _allegro_hline(dest,x,y+47,x+95,triframecolor);
                line(dest,x+47,y+7,x+15,y+39,triframecolor);
                line(dest,x+48,y+7,x+80,y+39,triframecolor);
                _allegro_hline(dest,x+15,y+40,x+80,triframecolor);
            }
        }
        
        if(showpieces)
        {
            for(int i=0; i<8; i++)
            {
                int lvl = i+1;
                
                if(get_bit(quest_rules,qr_4TRI) && lvl>4)
                    lvl -= 4;
                    
                if(has_item(itype_triforcepiece, lvl))
                {
                    int tp=0;
                    
                    for(; tp<8; tp++)
                        if(misc->triforce[tp] == i+1)
                            break;
                            
                    overtile16(dest,triforcetile,x+tripiece[0][tp][0],y+tripiece[0][tp][1],triforcecset,tripiece[0][tp][2]);
                }
            }
        }
    }
    else
    {
        if(showframe)
        {
            if(triframetile)
            {
                draw_block(dest,x,y,triframetile,triframecset,7,7);
            }
            else
            {
                if(!get_bit(quest_rules,qr_4TRI))
                {
                    //left inside vertical
                    _allegro_vline(dest,x+31,y+56,y+103,triframecolor);
                    _allegro_vline(dest,x+32,y+56,y+103,triframecolor);
                    
                    //center inside vertical top
                    _allegro_vline(dest,x+55,y+8   ,y+55,triframecolor);
                    _allegro_vline(dest,x+56,y+8   ,y+55,triframecolor);
                    
                    //right inside vertical
                    _allegro_vline(dest,x+79,y+56,y+103,triframecolor);
                    _allegro_vline(dest,x+80,y+56,y+103,triframecolor);
                    
                    if(!get_bit(quest_rules,qr_3TRI))
                    {
                        //center inside vertical bottom
                        _allegro_vline(dest,x+55,y+56,y+103,triframecolor);
                        _allegro_vline(dest,x+56,y+56,y+103,triframecolor);
                    }
                }
                
                //middle inside horizontal
                _allegro_hline(dest,x+32,y+55,x+79,triframecolor);
                _allegro_hline(dest,x+32,y+56,x+79,triframecolor);
                
                //bottom outside horizontal
                _allegro_hline(dest,x+8,y+103,x+103,triframecolor);
                
                //left outside diagonal
                line(dest,x+8,y+103,x+55,y+8,triframecolor);
                line(dest,x+9,y+102,x+55,y+9,triframecolor);
                
                //right outside diagonal
                line(dest,x+56,y+8,x+103,y+103,triframecolor);
                line(dest,x+56,y+9,x+102,y+102,triframecolor);
                
                //left inside diagonal
                line(dest,x+32,y+56,x+55,y+103,triframecolor);
                line(dest,x+32,y+57,x+54,y+102,triframecolor);
                line(dest,x+32,y+55,x+55,y+102,triframecolor);
                
                //right inside diagonal
                line(dest,x+56,y+103,x+79,y+56,triframecolor);
                line(dest,x+57,y+102,x+79,y+57,triframecolor);
                line(dest,x+56,y+102,x+79,y+55,triframecolor);
                
                for(int i=0; i<8; i++)
                {
                    int lvl = i+1;
                    
                    if(get_bit(quest_rules,qr_4TRI) && lvl>4)
                    {
                        lvl -= 4;
                    }
                    
                    int tp=0;
                    
                    for(; tp<8; tp++)
                    {
                        if(misc->triforce[tp] == i+1)
                        {
                            break;
                        }
                    }
                    
                    if(!has_item(itype_triforcepiece, lvl))
                    {
                        textprintf_ex(dest, pfont, x+tripiece[1][tp][0]+((tripiece[1][tp][2]&1)?8:14),y+tripiece[1][tp][1]+((tripiece[1][tp][2]&2)?9:32), numbercolor, -1, "%d", lvl);
                    }
                }
            }
        }
        
        if(showpieces)
        {
            for(int i=0; i<8; i++)
            {
                int lvl = i+1;
                
                if(get_bit(quest_rules,qr_4TRI) && lvl>4)
                {
                    lvl -= 4;
                }
                
                int tp=0;
                
                for(; tp<8; tp++)
                {
                    if(misc->triforce[tp] == i+1)
                    {
                        break;
                    }
                }
                
                if(has_item(itype_triforcepiece, lvl))
                {
                    draw_block_flip(dest,x+tripiece[1][tp][0]-(tripiece[1][tp][2]&1?0:8),y+tripiece[1][tp][1],triforcetile,triforcecset,2,3,tripiece[1][tp][2],1,0);
                }
            }
        }
    }
}


void puttriforce(BITMAP *dest, miscQdata *misc, int x, int y, int tile, int cset, int w, int h, int flip, bool overlay, bool trans, int trinum)
{
    if(tile==0)
    {
        tile=misc->colors.triforce_tile;
    }
    
    for(int i=0; i<8; i++)
    {
        int lvl = i+1;
        
        if(get_bit(quest_rules,qr_4TRI) && lvl>4)
            lvl -= 4;
            
        if(lvl==trinum && has_item(itype_triforcepiece, lvl))
        {
            int tp=0;
            
            for(; tp<8; tp++)
                if(misc->triforce[tp] == i+1)
                    break;
                    
            draw_block_flip(dest,x,y,tile,cset,w,h,flip,overlay,trans);
        }
    }
}

/*
  const byte bmap[16*2] = {
  0,0,1,0,0,1,0,0,1,0,0,0,1,0,0,0,
  0,3,0,0,0,3,0,0,0,0,3,0,0,0,3,0 };

  const int fringe[8] = { 6,2,4,7,6,8,7,5 };

  const byte bmaptiles[8*5] = {
  0, 1, 2, 3, 2, 3, 3, 4,
  20,21,22,23,22,23,23,24,
  20,21,22,23,22,23,23,24,
  20,21,22,23,22,23,23,24,
  40,41,42,43,42,43,43,44 };
  */

void draw_block(BITMAP *dest,int x,int y,int tile,int cset,int w,int h);
void putBmap(BITMAP *dest, miscQdata *misc, int x, int y,bool showmap, bool showrooms, bool showlink, int roomcolor, int linkcolor, bool large)
{
    int si=0;
    
    int maptile=has_item(itype_map, get_dlevel())?DMaps[get_currdmap()].largemap_2_tile:DMaps[get_currdmap()].largemap_1_tile;
    int mapcset=has_item(itype_map, get_dlevel())?DMaps[get_currdmap()].largemap_2_cset:DMaps[get_currdmap()].largemap_1_cset;
    
    if(showmap)
    {
        if(maptile)
        {
            draw_block(dest,x,y,maptile,mapcset,large?9:7,5);
        }
        else if(misc->colors.dungeon_map_tile)
        {
            for(int y2=0; y2<5; y2++)
            {
                for(int x2=0; x2<(large?8:6); x2++)
                {
                    overtile16(dest,misc->colors.dungeon_map_tile+(large?bmaptiles_original[y2][x2]:bmaptiles_bs[y2][x2]),x+(x2<<4),y+(y2<<4),misc->colors.dungeon_map_cset,0);
                    //++si;
                }
            }
        }
        else
        {
            BITMAP *bmp = create_bitmap_ex(8,8,8);
            
            if(!bmp)
                return;
                
            clear_bitmap(bmp);
            
            for(int x2=0; x2<8; x2++)
            {
                for(int y2=8-fringe[x2]; y2<8; y2++)
                {
                    putpixel(bmp,x2,y2,misc->colors.bmap_bg);
                }
            }
            
            rectfill(dest,x,y,x+(large?127:95),y+79,misc->colors.bmap_bg);
            
            for(int y2=0; y2<2; ++y2)
            {
                for(int x2=0; x2<(large?16:12); ++x2)
                {
                    if((large?bmap_original[y2][x2]:bmap_bs[y2][x2]))
                    {
                        rectfill(dest,(x2<<3)+x,(y2*72)+y,(x2<<3)+x+7,(y2*72)+y+7,misc->colors.subscr_bg);
                        
                        switch((large?bmap_original[y2][x2]:bmap_bs[y2][x2]))
                        {
                        case 3:
                            draw_sprite_v_flip(dest,bmp,(x2<<3)+x,(y2*72)+y);
                            break;
                            
                        case 1:
                        default:
                            draw_sprite(dest,bmp,(x2<<3)+x,(y2*72)+y);
                            break;
                        }
                    }
                }
            }
            
            destroy_bitmap(bmp);
        }
    }
    
    if(showrooms)
    {
        if(roomcolor==-1)
        {
            roomcolor = misc->colors.bmap_fg;
        }
        
        si=(get_currdmap()-1)<<6;
        
        for(int y2=y+8; y2<y+72; y2+=8)
        {
            for(int x2=x+(large?32:16)+(maptile?8:0); x2<x+(large?96:80)+(maptile?8:0); x2+=8)
            {
                if(get_bmaps(si))
                {
                    rectfill(dest,x2+1,y2+1,x2+6,y2+6,roomcolor);
                    
                    if(get_bmaps(si)&1) _allegro_hline(dest,x2+3,y2,  x2+4,roomcolor);  //top door
                    
                    if(get_bmaps(si)&2) _allegro_hline(dest,x2+3,y2+7,x2+4,roomcolor);  //bottom door
                    
                    if(get_bmaps(si)&4) _allegro_vline(dest,x2,  y2+3,y2+4,roomcolor);  //left door
                    
                    if(get_bmaps(si)&8) _allegro_vline(dest,x2+7,y2+3,y2+4,roomcolor);  //right door
                }
                
                ++si;
            }
        }
    }
    
    if(showlink)
    {
        if(get_currscr()<MAPSCRSNORMAL)
        {
            if(linkcolor==-1)
            {
                linkcolor=misc->colors.link_dot;
            }
            
            int xoff = (((DMaps[get_currdmap()].type&dmfTYPE)==dmOVERW) ? 0 : DMaps[get_currdmap()].xoff);
            putdot(dest,(((get_homescr()&15)-xoff)<<3)+x+(large?34:18)+(maptile?8:0),((get_homescr()&0xF0)>>1)+y+11,linkcolor);
        }
    }
}


void load_Sitems(miscQdata *misc)
{
    Sitems.clear();
    
    // HC Pieces
    if(misc->colors.HCpieces_tile)
    {
        //      item *HCP = new item((fix)(inventory_x[5]-ofs),(fix)y,iMax,0,0);
        item *HCP = new item((fix)0,(fix)0,(fix)0,iHCPiece,0,0);
        
        if(HCP)
        {
            int hcpphc =  game->get_hcp_per_hc();
            HCP->tile   = misc->colors.HCpieces_tile + vbound(game->get_HCpieces(),0,hcpphc > 0 ? hcpphc-1 : 0);
            HCP->o_tile = HCP->tile;
            HCP->cs     = misc->colors.HCpieces_cset;
            HCP->frames = 0;
            add_subscr_item(HCP);
        }
    }
    
    if(has_item(itype_map, get_dlevel()))
    {
        add_subscr_item(new item((fix)0,(fix)0,(fix)0,iMap,0,0));
    }
    
    if(has_item(itype_compass, get_dlevel()))
    {
        add_subscr_item(new item((fix)0,(fix)0,(fix)0,iCompass,0,0));
    }
    
    if(has_item(itype_bosskey, get_dlevel()))
    {
        add_subscr_item(new item((fix)0,(fix)0,(fix)0,iBossKey,0,0));
    }
    
    for(int i=0; i<itype_max; i++)
    {
        //special case: ignore the dmap-specific items processed above. -DD
        if(i == itype_map || i == itype_compass || i == itype_bosskey)
            continue;
            
        // Display the ring even if it has run out of magic.
        if(current_item_id(i,false)>-1)
        {
            int j = current_item_id(i,false);
            
            if(itemsbuf[j].tile)
                add_subscr_item(new item((fix)0, (fix)0,(fix)0,j,0,0));
        }
    }
    
    new_sel=true;
}

void update_subscreens(int dmap)
{
    if(dmap<0)
        dmap=get_currdmap();
        
    int index=DMaps[dmap].active_subscreen;
    
    int i=-1, j=0;
    
    while(custom_subscreen[j].objects[0].type!=ssoNULL&&i!=index)
    {
        if(custom_subscreen[j].ss_type==sstACTIVE)
        {
            ++i;
        }
        
        ++j;
    }
    
    current_subscreen_active=&custom_subscreen[j-1];
    
    index=DMaps[dmap].passive_subscreen;
    
    i=-1, j=0;
    
    while(custom_subscreen[j].objects[0].type!=ssoNULL&&i!=index)
    {
        if(custom_subscreen[j].ss_type==sstPASSIVE)
        {
            ++i;
        }
        
        ++j;
    }
    
    current_subscreen_passive=&custom_subscreen[j-1];
}

int ss_objects(subscreen_group *tempss)
{
    int i=0;
    
    while(i<MAXSUBSCREENITEMS&&tempss->objects[i].type!=ssoNULL)
    {
        ++i;
    }
    
    return i;
}


void purge_blank_subscreen_objects(subscreen_group *tempss)
{
    int objects=ss_objects(tempss);
    subscreen_object tempsso;
    
    //filter all the ssoNONE items to the end (yeah, bubble sort; sue me)
    for(int j=0; j<objects-1; j++)
    {
        for(int k=0; k<objects-1-j; k++)
        {
            if(tempss->objects[k].type==ssoNONE)
            {
                tempsso=tempss->objects[k];
                tempss->objects[k]=tempss->objects[k+1];
                tempss->objects[k+1]=tempsso;
            }
        }
    }
    
    //NULL out the ssoNONE items
    for(int j=0; j<objects; j++)
    {
        if(tempss->objects[j].type==ssoNONE)
        {
            tempss->objects[j].type=ssoNULL;
        }
    }
}



int get_alignment(subscreen_object *tempsso)
{
    switch(tempsso->type)
    {
    case ssoTEXT:
        return tempsso->d2;
        break;
        
    case ssoBSTIME:
        return sstaLEFT;
        break;
        
    case ssoTIME:
        return sstaRIGHT;
        break;
        
    case ssoSSTIME:
        return sstaRIGHT;
        break;
        
    case ssoCOUNTER:
        return tempsso->d2;
        break;
        
    case ssoMINIMAPTITLE:
        return tempsso->d2;
        break;
        
    case ssoCURRENTITEMTEXT:
    case ssoCURRENTITEMNAME:
    case ssoSELECTEDITEMNAME:
    case ssoCURRENTITEMCLASSTEXT:
    case ssoCURRENTITEMCLASSNAME:
    case ssoSELECTEDITEMCLASSNAME:
        return sstaLEFT;
        break;
        
    case ssoNONE:
    case sso2X2FRAME:
    case ssoLINE:
    case ssoRECT:
    case ssoMAGICMETER:
    case ssoLIFEMETER:
    case ssoBUTTONITEM:
    case ssoICON:
    case ssoCOUNTERS:
    case ssoMINIMAP:
    case ssoLARGEMAP:
    case ssoCLEAR:
    case ssoCURRENTITEM:
    case ssoITEM:
    case ssoTRIFRAME:
    case ssoTRIFORCE:
    case ssoTILEBLOCK:
    case ssoMINITILE:
    case ssoSELECTOR1:
    case ssoSELECTOR2:
    case ssoMAGICGAUGE:
    case ssoLIFEGAUGE:
    case ssoTEXTBOX:
    case ssoCURRENTITEMTILE:
    case ssoSELECTEDITEMTILE:
    default:
        return sstaLEFT;
        break;
    }
    
//  return false;//UNREACHABLE
}

//enum { sstsNORMAL, sstsSHADOW, sstsSHADOWU, sstsOUTLINE8, sstsOUTLINEPLUS, sstsOUTLINEX, sstsSHADOWED, sstsSHADOWEDU, sstsOUTLINED8, sstsOUTLINEDPLUS, sstsOUTLINEDX, sstsMAX };
//       "None",     "Shadow",   "Shadow (U)","Shadow (O)", "Shadow (+)",    "Shadow (X)", "Shadowed",   "Shadowed (U)","Shadowed (O)","Shadowed (+)",   "Shadowed (X)"
//x-1
//sstsSHADOWU, sstsOUTLINE8, sstsOUTLINEPLUS, sstsOUTLINEX, sstsSHADOWEDU, sstsOUTLINED8, sstsOUTLINEDPLUS, sstsOUTLINEDX
//w+1
//sstsSHADOW, sstsSHADOWU, sstsOUTLINE8, sstsOUTLINEPLUS, sstsOUTLINEX, sstsSHADOWED, sstsSHADOWEDU, sstsOUTLINED8, sstsOUTLINEDPLUS, sstsOUTLINEDX
//y-1
//sstsOUTLINE8, sstsOUTLINEPLUS, sstsOUTLINEX, sstsOUTLINED8, sstsOUTLINEDPLUS, sstsOUTLINEDX
//h+1
//sstsSHADOW, sstsSHADOWU, sstsOUTLINE8, sstsOUTLINEPLUS, sstsOUTLINEX, sstsSHADOWED, sstsSHADOWEDU, sstsOUTLINED8, sstsOUTLINEDPLUS, sstsOUTLINEDX

int sso_y(subscreen_object *tempsso)
{
    int y=0;
    
    switch(tempsso->type)
    {
    case ssoLIFEMETER:
        y=tempsso->y+(tempsso->d2?0:(tempsso->d3?8:16));
        break;
        
    case ssoNONE:
    case sso2X2FRAME:
    case ssoTEXT:
    case ssoLINE:
    case ssoRECT:
    case ssoBSTIME:
    case ssoTIME:
    case ssoSSTIME:
    case ssoMAGICMETER:
    case ssoBUTTONITEM:
    case ssoICON:
    case ssoCOUNTER:
    case ssoCOUNTERS:
    case ssoMINIMAPTITLE:
    case ssoMINIMAP:
    case ssoLARGEMAP:
    case ssoCLEAR:
    case ssoCURRENTITEM:
    case ssoITEM:
    case ssoTRIFRAME:
    case ssoTRIFORCE:
    case ssoTILEBLOCK:
    case ssoMINITILE:
    case ssoSELECTOR1:
    case ssoSELECTOR2:
    case ssoMAGICGAUGE:
    case ssoLIFEGAUGE:
    case ssoTEXTBOX:
    case ssoCURRENTITEMTILE:
    case ssoSELECTEDITEMTILE:
    case ssoCURRENTITEMTEXT:
    case ssoCURRENTITEMNAME:
    case ssoSELECTEDITEMNAME:
    case ssoCURRENTITEMCLASSTEXT:
    case ssoCURRENTITEMCLASSNAME:
    case ssoSELECTEDITEMCLASSNAME:
        y=tempsso->y;
        break;
        
    default:
        y=(rand()*1000)%64;
        break;
    }
    
    switch(tempsso->type)
    {
    case ssoTEXT:
    case ssoBSTIME:
    case ssoTIME:
    case ssoSSTIME:
    case ssoCOUNTER:
    case ssoCOUNTERS:
        switch(tempsso->d3)
        {
        case sstsOUTLINE8:
        case sstsOUTLINEPLUS:
        case sstsOUTLINEX:
        case sstsOUTLINED8:
        case sstsOUTLINEDPLUS:
        case sstsOUTLINEDX:
            y-=1;
            break;
        }
        
        break;
    }
    
    return y;
}

int sso_x(subscreen_object *tempsso)
{
    int x=0;
    
    switch(tempsso->type)
    {
    case ssoMAGICMETER:
        x=tempsso->x-10;
        break;
        
    case ssoNONE:
    case sso2X2FRAME:
    case ssoTEXT:
    case ssoLINE:
    case ssoRECT:
    case ssoBSTIME:
    case ssoTIME:
    case ssoSSTIME:
    case ssoLIFEMETER:
    case ssoBUTTONITEM:
    case ssoICON:
    case ssoCOUNTER:
    case ssoCOUNTERS:
    case ssoMINIMAPTITLE:
    case ssoMINIMAP:
    case ssoLARGEMAP:
    case ssoCLEAR:
    case ssoCURRENTITEM:
    case ssoITEM:
    case ssoTRIFRAME:
    case ssoTRIFORCE:
    case ssoTILEBLOCK:
    case ssoMINITILE:
    case ssoSELECTOR1:
    case ssoSELECTOR2:
    case ssoMAGICGAUGE:
    case ssoLIFEGAUGE:
    case ssoTEXTBOX:
    case ssoCURRENTITEMTILE:
    case ssoSELECTEDITEMTILE:
    case ssoCURRENTITEMTEXT:
    case ssoCURRENTITEMNAME:
    case ssoSELECTEDITEMNAME:
    case ssoCURRENTITEMCLASSTEXT:
    case ssoCURRENTITEMCLASSNAME:
    case ssoSELECTEDITEMCLASSNAME:
        x=tempsso->x;
        break;
        
    default:
        x=(rand()*1000)%64;
        break;
    }
    
    switch(tempsso->type)
    {
    case ssoTEXT:
    case ssoBSTIME:
    case ssoTIME:
    case ssoSSTIME:
    case ssoCOUNTER:
    case ssoCOUNTERS:
        switch(tempsso->d3)
        {
        case sstsSHADOWU:
        case sstsOUTLINE8:
        case sstsOUTLINEPLUS:
        case sstsOUTLINEX:
        case sstsSHADOWEDU:
        case sstsOUTLINED8:
        case sstsOUTLINEDPLUS:
        case sstsOUTLINEDX:
            x-=1;
            break;
        }
        
        break;
    }
    
    return x;
}



int sso_h(subscreen_object *tempsso)
{
    int h=0;
    
    switch(tempsso->type)
    {
    case ssoNONE:
        h=5;
        break;
        
    case sso2X2FRAME:
        h=tempsso->h*8;
        break;
        
    case ssoTEXT:
        h=text_height(ss_font(tempsso->d1));
        break;
        
    case ssoLINE:
        h=tempsso->h;
        break;
        
    case ssoRECT:
        h=tempsso->h;
        break;
        
    case ssoBSTIME:
        h=text_height(ss_font(tempsso->d1));
        break;
        
    case ssoTIME:
        h=text_height(ss_font(tempsso->d1));
        break;
        
    case ssoSSTIME:
        h=text_height(ss_font(tempsso->d1));
        break;
        
    case ssoMAGICMETER:
        h=8;
        break;
        
    case ssoLIFEMETER:
        h=tempsso->d3?24:16;
        break;
        
    case ssoBUTTONITEM:
        h=16;
        break;
        
    case ssoICON:
        h=8;
        break;
        
    case ssoCOUNTER:
        h=text_height(ss_font(tempsso->d1));
        break;
        
    case ssoCOUNTERS:
        h=32;
        break;
        
    case ssoMINIMAPTITLE:
        h=16;
        break;
        
    case ssoMINIMAP:
        h=48;
        break;
        
    case ssoLARGEMAP:
        h=80;
        break;
        
    case ssoCLEAR:
        h=5;
        break;
        
    case ssoCURRENTITEM:
        h=16;
        break;
        
    case ssoITEM:
        h=16;
        break;
        
    case ssoTRIFRAME:
        h=16*((tempsso->d7)?7:3);
        break;
        
    case ssoTRIFORCE:
        h=16;
        break;
        
    case ssoTILEBLOCK:
        h=16*(tempsso->h);
        break;
        
    case ssoMINITILE:
        h=8;
        break;
        
    case ssoSELECTOR1:
    case ssoSELECTOR2:
        h=tempsso->d5?32:16;
        break;
        
    case ssoMAGICGAUGE:
        h=8;
        break;
        
    case ssoLIFEGAUGE:
        h=8;
        break;
        
    case ssoTEXTBOX:
        h=tempsso->h;
        break;
        
    case ssoCURRENTITEMTILE:
        h=16;
        break;
        
    case ssoSELECTEDITEMTILE:
        h=16;
        break;
        
    case ssoCURRENTITEMTEXT:
        h=16;
        break;
        
    case ssoCURRENTITEMNAME:
        h=tempsso->h;
        break;
        
    case ssoSELECTEDITEMNAME:
        h=tempsso->h;
        break;
        
    case ssoCURRENTITEMCLASSTEXT:
        h=tempsso->h;
        break;
        
    case ssoCURRENTITEMCLASSNAME:
        h=tempsso->h;
        break;
        
    case ssoSELECTEDITEMCLASSNAME:
        h=tempsso->h;
        break;
        
    default:
        h=(rand()*1000)%64;
        break;
    }
    
    switch(tempsso->type)
    {
    case ssoTEXT:
    case ssoBSTIME:
    case ssoTIME:
    case ssoSSTIME:
    case ssoCOUNTER:
    case ssoCOUNTERS:
        switch(tempsso->d3)
        {
        case sstsSHADOW:
        case sstsSHADOWU:
        case sstsOUTLINE8:
        case sstsOUTLINEPLUS:
        case sstsOUTLINEX:
        case sstsSHADOWED:
        case sstsSHADOWEDU:
        case sstsOUTLINED8:
        case sstsOUTLINEDPLUS:
        case sstsOUTLINEDX:
            h+=1;
            break;
        }
        
        break;
    }
    
    return h;
}

int sso_w(subscreen_object *tempsso)
{
    int w=0;
    
    switch(tempsso->type)
    {
    case ssoNONE:
        w=5;
        break;
        
    case sso2X2FRAME:
        w=tempsso->w*8;
        break;
        
    case ssoTEXT:
        w=text_length(ss_font(tempsso->d1), (char *)tempsso->dp1);
        break;
        
    case ssoLINE:
        w=tempsso->w;
        break;
        
    case ssoRECT:
        w=tempsso->w;
        break;
        
    case ssoBSTIME:
        w=text_length(ss_font(tempsso->d1), time_str_short2(game->get_time()));
        break;
        
    case ssoTIME:
        w=text_length(ss_font(tempsso->d1), time_str_med(game->get_time()));
        break;
        
    case ssoSSTIME:
        w=text_length(ss_font(tempsso->d1), time_str_med(game->get_time()));
        break;
        
    case ssoMAGICMETER:
        w=82;
        break;
        
    case ssoLIFEMETER:
        w=64;
        break;
        
    case ssoBUTTONITEM:
        w=16;
        break;
        
    case ssoICON:
        w=8;
        break;
        
    case ssoCOUNTER:
        w=text_length(ss_font(tempsso->d1), "0")*tempsso->d4;
        break;
        
    case ssoCOUNTERS:
        w=32;
        break;
        
    case ssoMINIMAPTITLE:
        w=80;
        break;
        
    case ssoMINIMAP:
        w=80;
        break;
        
    case ssoLARGEMAP:
        w=16*((tempsso->d4)?9:7);
        break;
        
    case ssoCLEAR:
        w=5;
        break;
        
    case ssoCURRENTITEM:
        w=16;
        break;
        
    case ssoITEM:
        w=16;
        break;
        
    case ssoTRIFRAME:
        w=16*((tempsso->d7)?7:6);
        break;
        
    case ssoTRIFORCE:
        w=16;
        break;
        
    case ssoTILEBLOCK:
        w=16*(tempsso->w);
        break;
        
    case ssoMINITILE:
        w=8;
        break;
        
    case ssoSELECTOR1:
    case ssoSELECTOR2:
        w=tempsso->d5?32:16;
        break;
        
    case ssoMAGICGAUGE:
        w=8;
        break;
        
    case ssoLIFEGAUGE:
        w=8;
        break;
        
    case ssoTEXTBOX:
        w=tempsso->w;
        break;
        
    case ssoCURRENTITEMTILE:
        w=16;
        break;
        
    case ssoSELECTEDITEMTILE:
        w=16;
        break;
        
    case ssoCURRENTITEMTEXT:
        w=16;
        break;
        
    case ssoCURRENTITEMNAME:
        w=tempsso->w;
        break;
        
    case ssoSELECTEDITEMNAME:
        w=tempsso->w;
        break;
        
    case ssoCURRENTITEMCLASSTEXT:
        w=tempsso->w;
        break;
        
    case ssoCURRENTITEMCLASSNAME:
        w=tempsso->w;
        break;
        
    case ssoSELECTEDITEMCLASSNAME:
        w=tempsso->w;
        break;
        
    default:
        w=(rand()*1000)%64;
        break;
    }
    
    switch(tempsso->type)
    {
    case ssoTEXT:
    case ssoBSTIME:
    case ssoTIME:
    case ssoSSTIME:
    case ssoCOUNTER:
    case ssoCOUNTERS:
        switch(tempsso->d3)
        {
        case sstsSHADOW:
        case sstsSHADOWU:
        case sstsOUTLINE8:
        case sstsOUTLINEPLUS:
        case sstsOUTLINEX:
        case sstsSHADOWED:
        case sstsSHADOWEDU:
        case sstsOUTLINED8:
        case sstsOUTLINEDPLUS:
        case sstsOUTLINEDX:
            w+=1;
            break;
        }
        
        break;
    }
    
    return w;
}

void sso_bounding_box(BITMAP *bmp, subscreen_group *tempss, int index, int color)
{
    if(index<0)
    {
        return;
    }
    
    int x=sso_x(&tempss->objects[index]);
    int y=sso_y(&tempss->objects[index]);
    int w=sso_w(&tempss->objects[index]);
    int h=sso_h(&tempss->objects[index]);
    
    switch(get_alignment(&tempss->objects[index]))
    {
    case sstaCENTER:
        x-=(w/2);
        break;
        
    case sstaRIGHT:
        x-=w;
        break;
        
    case sstaLEFT:
    default:
        break;
    }
    
    int c=x+w/2;
    int m=y+h/2;
    bool normalrect=true;
    
    if(color==-1)
    {
        color=jwin_pal[jcTITLER];
    }
    else if(color==-2)
    {
        color=jwin_pal[jcTITLEL];
    }
    
    //draw a bounding box around the current object
    if(normalrect)
    {
        rect(bmp, x, y, x+w-1, y+h-1, color);
    }
    else
    {
        rect(bmp, x-1,   y-1,   x+1, y+1, color);
        rect(bmp, x-1,   y+h-2, x+1, y+h, color);
        rect(bmp, x+w-2, y-1,   x+w, y+1, color);
        rect(bmp, x+w-2, y+h-2, x+w, y+h, color);
        
        if(w>=9)
        {
            rect(bmp, c-1, y-1,   c+1, y+1, color);
            rect(bmp, c-1, y+h-2, c+1, y+h, color);
            _allegro_hline(bmp, x+2,  y,     c-2,  color);
            _allegro_hline(bmp, c+2, y,     x+w-3, color);
            _allegro_hline(bmp, x+2,  y+h-1, c-2,  color);
            _allegro_hline(bmp, c+2, y+h-1, x+w-3, color);
        }
        else
        {
            _allegro_hline(bmp, x+2,  y,     x+w-3, color);
            _allegro_hline(bmp, x+2,  y+h-1, x+w-3, color);
        }
        
        if(h>=9)
        {
            rect(bmp, x-1,   m-1, x+1, m+1, color);
            rect(bmp, x+w-2, m-1, x+w, m+1, color);
            _allegro_vline(bmp, x,     y+2,  m-2,  color);
            _allegro_vline(bmp, x,     m+2, y+h-3, color);
            _allegro_vline(bmp, x+w-1, y+2,  m-2,  color);
            _allegro_vline(bmp, x+w-1, m+2, y+h-3, color);
        }
        else
        {
            _allegro_vline(bmp, x,     y+2,  y+h-3, color);
            _allegro_vline(bmp, x+w-1, y+2,  y+h-3, color);
        }
    }
}


/*** end of subscr.cc ***/

